SystemOrganization addCategory: #Mapless!
SystemOrganization addCategory: #'Mapless-Core'!
SystemOrganization addCategory: #'Mapless-Errors'!
SystemOrganization addCategory: #'Mapless-Models'!
SystemOrganization addCategory: #'Mapless-Mongo'!
SystemOrganization addCategory: #'Mapless-Mongo-Errors'!
SystemOrganization addCategory: #'Mapless-Mongo-Tests'!
SystemOrganization addCategory: #'Mapless-Redis'!
SystemOrganization addCategory: #'Mapless-Redis-Errors'!
SystemOrganization addCategory: #'Mapless-Redis-Tests'!

TestCase subclass: #MaplessMongoModelTest
	instanceVariableNames: 'pool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo-Tests'!

!MaplessMongoModelTest methodsFor: 'actions' stamp: 'sebastiansastre 2/8/2013 15:45'!
do: aBlock 

	^ pool databaseAt: 'Mapless-Tests' do: aBlock ! !

!MaplessMongoModelTest methodsFor: 'setUp-tearDown' stamp: 'paulwilke 2/7/2013 18:05'!
setUp
	super setUp.
	pool := MongoPool instance.! !

!MaplessMongoModelTest methodsFor: 'setUp-tearDown' stamp: 'paulwilke 2/7/2013 19:49'!
tearDown
	super tearDown.
	pool reset.
	pool := nil! !

!MaplessMongoModelTest methodsFor: 'tests' stamp: 'sebastiansastre 5/29/2013 22:13'!
testUnrefDestroy

	"Tests MaplessMongoModel>>#unreferenced"
	| person tagsCollection loaded reified reloaded |
	
	tagsCollection := OrderedCollection new
		 add: (MaplessMongoDummyTag new
			isCustomer: true;
			yourself);
		add: (MaplessMongoDummyTag new
			isComplicated: false;
			yourself); 
		yourself.
			
	person := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.
	"Save all tags in the collection"
	person tags: tagsCollection.
	self assert: person isUnsaved.
	"save tagsCollection"	
	tagsCollection do: [:e | self do:[ e save]].
	
	self do:[person save].
	self deny: person isUnsaved.
	
	self do:[ loaded := MaplessMongoDummyPerson findAt: person oid].
	
	self assert: loaded notNil.
	self deny: loaded isUnsaved.
	
	self do: [ reified := loaded unreferenced ].

	self assert: reified data tags class = OrderedCollection.
	self assert: (reified data tags first class = MaplessReference) not. 
	self assert: (reified data tags second class = MaplessReference) not.
	
	self assert: reified data tags first isCustomer.
	self assert: (reified data tags second isComplicated = false).
	
	self do: [ reified destroy].
	"self do: [ loaded destroy].
	"
	self assert: ( self do: [ reloaded := MaplessMongoDummyPerson existsAt: reified oid]) not.	

! !

!MaplessMongoModelTest methodsFor: 'tests' stamp: 'sebastiansastre 5/29/2013 21:51'!
testUnrefDestroy2

	| friends guy stuff loaded reified reloaded | 
	
	friends := OrderedCollection new
				add: (MaplessMongoDummyPerson new
						firstName: 'Frodo';
						yourself);
				add: (MaplessMongoDummyPerson new
						firstName: 'Gandalf';
						yourself);
				add: (MaplessMongoDummyPerson new
						firstName: 'Boromir';
						yourself);
				yourself.
				
	stuff := #('Ice cream' 'waffles' 'french fries').
	
	guy := MaplessMongoDummyPerson new
				firstName: 'dude';
				favorites: stuff;
				friends: friends;
				yourself.
	
	self do: [friends do: [:e | e save]].
	self do:[guy save].
	self deny: guy isUnsaved.
	
	self do:[ loaded := MaplessMongoDummyPerson findAt: guy oid].
	
	self assert: loaded notNil.
	self deny: loaded isUnsaved.
	
	self do: [ reified := loaded unreferenced ].

	self assert: reified data friends class = OrderedCollection.
	self do: [ reified destroy].

	"By design, the destruction should be to the individual aggregate (and not its submodels).
	It's programmers' responsability to decide when to destroy a sub aggregate"	
	self assert: ( self do: [ reloaded := MaplessMongoDummyPerson existsAt: loaded oid]) not.	
	self do:[self assert: ((friends collect: [:e| e oid]) allSatisfy: [:guyOid|
					(MaplessMongoDummyPerson existsAt: guyOid)])]

				
	! !

!MaplessMongoModelTest methodsFor: 'tests' stamp: 'sebastiansastre 5/29/2013 22:13'!
testUnreferenced
	"Tests MaplessMongoModel>>#unreferenced"
	| person tagsCollection loaded reified |
	
	tagsCollection := OrderedCollection new
		 add: (MaplessMongoDummyTag new
			isCustomer: true;
			yourself);
		add: (MaplessMongoDummyTag new
			isComplicated: false;
			yourself); 
		yourself.
			
	person := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.
	"Save all tags in the collection"
	person tags: tagsCollection.
	self assert: person isUnsaved.
	"save tagsCollection"	
	tagsCollection do: [:e | self do:[ e save]].
	
	self do:[person save].
	self deny: person isUnsaved.
	
	self do:[ loaded := MaplessMongoDummyPerson findAt: person oid].
	
	self assert: loaded notNil.
	self deny: loaded isUnsaved.
	
	self do: [ reified := loaded unreferenced ].

	self assert: reified data tags class = OrderedCollection.
	self assert: (reified data tags first class = MaplessReference) not. 
	self assert: (reified data tags second class = MaplessReference) not.
	
	self assert: reified data tags first isCustomer.
	self assert: (reified data tags second isComplicated = false).! !

!MaplessMongoModelTest methodsFor: 'tests' stamp: 'sebastiansastre 5/29/2013 21:51'!
testUnreferenced2

	| friends guy stuff loaded reified | 
	
	friends := OrderedCollection new
				add: (MaplessMongoDummyPerson new
						firstName: 'Frodo';
						yourself);
				add: (MaplessMongoDummyPerson new
						firstName: 'Gandalf';
						yourself);
				add: (MaplessMongoDummyPerson new
						firstName: 'Boromir';
						yourself);
				yourself.
				
	stuff := #('Ice cream' 'waffles' 'french fries') asOrderedCollection.
	
	guy := MaplessMongoDummyPerson new
				firstName: 'dude';
				favorites: stuff;
				friends: friends;
				yourself.
	
	friends do: [:e | self do:[ e save]].
	self do:[guy save].
	self deny: guy isUnsaved.
	
	self do:[ loaded := MaplessMongoDummyPerson findAt: guy oid].
	
	self assert: loaded notNil.
	self deny: loaded isUnsaved.
	
	self do: [ reified := loaded unreferenced ].

	self assert: reified data friends class = OrderedCollection.
	self assert: reified data favorites = stuff.
				
	! !

TestCase subclass: #MaplessMongoTest
	instanceVariableNames: 'pool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo-Tests'!

!MaplessMongoTest class methodsFor: 'history' stamp: 'sebastiansastre 12/3/2012 18:19'!
lastStoredRun
	^ ((Dictionary new) add: (#passed->((Set new) add: #testDefaultCategoryCleanUp; add: #testPackageCleanUp; add: #testSingleClassCreation; add: #testClassCreationInDifferentCategories; add: #testClassFastCreationInDifferentCategories; add: #testMultipleClassCreation; add: #testSingleClassFastCreation; yourself)); add: (#timeStamp->'22 November 2008 10:11:35 pm'); add: (#failures->((Set new))); add: (#errors->((Set new))); yourself)! !

!MaplessMongoTest methodsFor: 'actions' stamp: 'sebastiansastre 1/4/2013 23:05'!
do: aBlock 

	^ pool databaseAt: 'Mapless-Tests' do: aBlock ! !

!MaplessMongoTest methodsFor: 'setUp-tearDown' stamp: 'sebastiansastre 12/3/2012 18:21'!
setUp
	super setUp.
	pool := MongoPool instance.! !

!MaplessMongoTest methodsFor: 'setUp-tearDown' stamp: 'sebastiansastre 12/4/2012 19:02'!
tearDown
	super tearDown.

	pool reset.
	pool := nil! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testComposedAccess
	"Test proxies and its on-demand-load and DNU mechanism"

	| user guy |
	
	user := MaplessMongoDummyUser new
				userame: 'johnq';
				yourself.
	
	guy := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	user person: guy.

	self do:[ 
		guy save.
		user save ].
	
	self do:[
		self assert: ( MaplessMongoDummyUser findAt: user oid ) completeName = 'john q'.
		self assert: ( MaplessMongoDummyUser findAt: user oid ) person class = MaplessReference.
		self assert: ( MaplessMongoDummyUser findAt: user oid ) person model class = MaplessMongoDummyPerson.
		self assert: ( MaplessMongoDummyUser findAt: user oid ) person firstName = 'john'.
		self assert: ( MaplessMongoDummyUser findAt: user oid ) person lastName = 'q' ]
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testComposedDelete

	| users |
	
	users := OrderedCollection new.

	Character alphabet do: [ :char |
		users add: (MaplessMongoDummyUser new 
					userame: char asString;
					person: (MaplessMongoDummyPerson new
								firstName: char asString;
								yourself);
					yourself)].
	
	self assert: ( users allSatisfy: [ :user | user isUnsaved ] ).	
	self assert: ( users allSatisfy: [ :user | user person isUnsaved ] ).	

	self do:[ users do:[ :user | user person save ] ].
	self do:[ users do:[ :user | user save ] ].

	self assert: ( users allSatisfy: [ :user | user isUnsaved not ] ).	
	self assert: ( users allSatisfy: [ :user | user person isUnsaved not ] ).	
	self assert: ( users allSatisfy: [ :user | user isDeleted not ] ).	
	self assert: ( users allSatisfy: [ :user | user person isDeleted not ] ).	

	self do:[ users do:[ :user | user person delete ] ].
	
	self assert: ( users allSatisfy: [ :user | user person isDeleted ] ).	
	self assert: ( users allSatisfy: [ :user | user isDeleted not ] ).	

	self do:[ users do:[ :user | user delete ] ].

	self assert: ( users allSatisfy: [ :user | user person isDeleted ] ).	
	self assert: ( users allSatisfy: [ :user | user isDeleted ] ).	
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testComposedDestroy

	| users |
	
	users := OrderedCollection new.

	Character alphabet do: [ :char |
		users add: (MaplessMongoDummyUser new 
					userame: char asString;
					person: (MaplessMongoDummyPerson new
								firstName: char asString;
								yourself);
					yourself)].
	
	self assert: ( users allSatisfy: [ :user | user isUnsaved ] ).	
	self assert: ( users allSatisfy: [ :user | user person isUnsaved ] ).	

	self do:[ users do:[ :user | user person save ] ].
	self do:[ users do:[ :user | user save ] ].

	self assert: ( users allSatisfy: [ :user | user isUnsaved not ] ).	
	self assert: ( users allSatisfy: [ :user | user person isUnsaved not ] ).	

	self do:[ users do:[ :user | user person destroy ] ].
	
	self do:[
		self assert: ( users allSatisfy: [ :user | ( MaplessMongoDummyPerson existsAt: user person oid ) not] ).	
		self assert: ( users allSatisfy: [ :user | MaplessMongoDummyUser existsAt: user oid ] ) ].	

	self do:[ users do:[ :user | user destroy ] ].

	self assert: ( self do: [ users allSatisfy: [ :user | (MaplessMongoDummyUser existsAt: user oid) not ] ] ).	
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 17:18'!
testComposedSave

	| user guy |
	
	user := MaplessMongoDummyUser new
				userame: 'johnq';
				yourself.
	
	guy := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	user person: guy.
		
	"Whithout saving a submodel"
	self assert: user isUnsaved.	
	self assert: guy isUnsaved.	
	self should: [ self do:[ user save ] ] raise: MaplessUnsavedSubmodel.

	"After saving that submodel"
	self do:[ guy save ].
	self shouldnt: [ self do:[ user save ] ] raise: MaplessUnsavedSubmodel.
	
	self deny: user isUnsaved.	
	self deny: guy isUnsaved.	

! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 17:18'!
testComposedSaveAndLoad

	| user guy loaded |
	
	user := MaplessMongoDummyUser new
				username: 'johnq';
				yourself.
	
	guy := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	user person: guy.
		
	"Whithout saving a submodel"
	self assert: user isUnsaved.	
	self assert: guy isUnsaved.	
	self should: [ self do:[ user save ] ] raise: MaplessUnsavedSubmodel.

	"After saving that submodel"
	self do:[ guy save ].
	self shouldnt: [ self do:[ user save ] ] raise: MaplessUnsavedSubmodel.
	
	self deny: user isUnsaved.	
	self deny: guy isUnsaved.	

	self do:[ loaded := MaplessMongoDummyUser findAt: user oid.
		self assert: loaded notNil.
		self deny: loaded isUnsaved.
		self assert: loaded data = user data.
		self assert: loaded username = 'johnq'.
		self assert: loaded person firstName = 'john'.
		self assert: loaded person lastName = 'q'.
		self assert: loaded person modelClass = MaplessMongoDummyPerson asString.
		self assert: loaded person model class = MaplessMongoDummyPerson.
		]
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testComposition

	| user guy |
	
	user := MaplessMongoDummyUser new
				userame: 'johnq';
				yourself.
	
	guy := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	user person: guy.
		
	self assert: guy isUnsaved.	
	self assert: ((user data at: 'person') class = MaplessReference).
	self assert: ((user data at: 'person') modelClass = #MaplessMongoDummyPerson).
	self assert: ((user data at: 'person') oid = guy oid).
	self assert: (user completeName = 'john q').
	
	
	! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testDateAndTime

	| when guy loaded |
	
	when := DateAndTime now.
	guy := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			createdOn: when;
			yourself.
	
	self assert: guy isUnsaved.	
	self do:[ guy save ].
	self deny: guy isUnsaved.

	self do:[ loaded := MaplessMongoDummyPerson findAt: guy id ].

	self assert: loaded createdOn asDate = when asDate.
	self assert: loaded createdOn asTime = when asTime .
	self assert: loaded createdOn = when.
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testDelete

	| people |
	
	people := OrderedCollection new.

	Character alphabet do: [ :char |
		people add: (MaplessMongoDummyPerson new
						firstName: char asString;
						yourself)].
	
	self assert: ( people allSatisfy: [ :guy | guy isUnsaved ] ).	

	self do:[ people do:[ :guy | guy save ] ].

	self assert: ( people allSatisfy: [ :guy | guy isUnsaved not ] ).	
	self assert: ( people allSatisfy: [ :guy | guy isDeleted not ] ).	
	
	self do:[ people do:[ :guy | guy delete ] ].
	self assert: ( people allSatisfy: [ :guy | guy isDeleted ] ).	
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testDestroy

	| people |
	
	people := OrderedCollection new.

	Character alphabet do: [ :char |
		people add: (MaplessMongoDummyPerson new
						firstName: char asString;
						yourself)].
	
	self assert: ( people allSatisfy: [ :guy | guy isUnsaved ] ).	

	self do:[ people do:[ :guy | guy save ] ].

	self assert: ( people allSatisfy: [ :guy | guy isUnsaved not ] ).	
	self assert: ( people allSatisfy: [ :guy | guy isDeleted not ] ).	
	
	self do:[ people do:[ :guy | guy destroy ] ].
	self assert: ( self do:[ people allSatisfy: [ :guy | ( MaplessMongoDummyPerson existsAt: guy oid ) not ] ]).
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 17:18'!
testMultipleComposedComposables

	| tags tagsOfTags tagsOfTagsOfTags loaded |

	tags := OrderedCollection new.
	tagsOfTags := OrderedCollection new.
	tagsOfTagsOfTags := OrderedCollection new.

	tags 
		add: (MaplessMongoDummyTag new label: 'is this'; yourself);	
		add: (MaplessMongoDummyTag new label: 'multiply'; yourself);	
		add: (MaplessMongoDummyTag new label: 'composable?'; yourself);	
		yourself.

	tagsOfTags 
		add: (MaplessMongoDummyTag new label: 'like'; yourself);	
		add: (MaplessMongoDummyTag new label: 'really?'; yourself);	
		yourself.

	tagsOfTagsOfTags  
		add: (MaplessMongoDummyTag new label: 'wow'; yourself);	
		add: (MaplessMongoDummyTag new label: 'nice'; yourself);	
		yourself.

	self do:[ tagsOfTagsOfTags do:[ :tag | tag save] ].
	tagsOfTags first tags: tagsOfTagsOfTags.
	tagsOfTags second tags: tagsOfTagsOfTags.
	self shouldnt: [ self do:[ tagsOfTags do:[:tag| tag save ] ]] raise: MaplessUnsavedSubmodel.

	tags first tags: tagsOfTags.
	tags second tags: tagsOfTags.
	tags third tags: tagsOfTags.
	self shouldnt: [ self do:[ tags do:[:e| e save ] ]] raise: MaplessUnsavedSubmodel.
	
	self deny: (tagsOfTagsOfTags anySatisfy: [:tag| tag isUnsaved]).	
	self deny: (tagsOfTags anySatisfy: [:tag| tag isUnsaved]).	
	self deny: (tags anySatisfy: [:tag| tag isUnsaved]).	

	self do:[ 
		loaded := MaplessMongoDummyTag findAt: tags first oid.
		self assert: loaded notNil.
		self deny: loaded isUnsaved.
		self assert: loaded label = 'is this'.
		self assert: loaded tags isCollection.
		self assert: loaded tags notEmpty.
		self assert: loaded tags isCollection.
		self deny: loaded tags first tags isEmpty.
		self assert: loaded tags first label = 'like'.
		self assert: loaded tags second label = 'really?'.
		self assert: loaded tags size = 2.
		self deny: loaded tags first tags isEmpty.
		self assert: loaded tags first tags size = 2.
		self assert: loaded tags first tags first label = 'wow'.
		self assert: loaded tags first tags second label = 'nice'.
		]
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 17:18'!
testMultipleComposedSaveAndLoad

	| user guy tags loaded |
	
	user := MaplessMongoDummyUser new
				username: 'johnq';
				yourself.
	
	guy := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	tags := OrderedCollection new.
	tags 
		add: (MaplessMongoDummyTag new label: 'cool'; yourself);	
		add: (MaplessMongoDummyTag new label: 'stuff'; yourself);	
		yourself.
		
	user 
		person: guy;
		tags: tags;
		yourself.
		
	self do:[ tags do:[ :tag | tag save] ].
	self do:[ guy save ].
	self shouldnt: [ self do:[ user save ] ] raise: MaplessUnsavedSubmodel.
	
	self deny: user isUnsaved.	
	self deny: guy isUnsaved.	
	self assert: (tags allSatisfy: [:e| e isUnsaved not]).

	self do:[ loaded := MaplessMongoDummyUser findAt: user oid.
		self assert: loaded notNil.
		self deny: loaded isUnsaved.
		self assert: loaded username = 'johnq'.
		self assert: loaded tags isCollection.
		self assert: loaded tags notEmpty.
		self assert: loaded tags isCollection.
		self assert: (loaded tags allSatisfy: [:e| tags includes: e]).
		]
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testQueryUsers

	| users |
	
	users := OrderedCollection new.

	Character alphabet do: [ :char |
		users add: (MaplessMongoDummyUser new 
					username: char asString;
					person: (MaplessMongoDummyPerson new
								firstName: char asString;
								yourself);
					yourself)].
	
	self assert: ( users allSatisfy: [ :user | user isUnsaved ] ).	
	self assert: ( users allSatisfy: [ :user | user person isUnsaved ] ).	

	self do:[ users do:[ :user | user person save ] ].
	self do:[ users do:[ :user | user save ] ].

	self do:[ 
		self assert: (Character alphabet allSatisfy: [ :char | 
						( MaplessMongoDummyUser findUsername: char asString ) notNil ] ) ]
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testSimpleSave

	| guy |
	
	guy := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.
	
	self assert: guy isUnsaved.	
	self do:[ guy save ].
	self deny: guy isUnsaved.
! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testSimpleSaveAndLoad
	| guy loaded |
	
	guy := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.
	
	self assert: guy isUnsaved.	
	self do:[guy save].
	self deny: guy isUnsaved.

	self do:[ loaded := MaplessMongoDummyPerson findAt: guy oid ].
	self assert: loaded notNil.
	self deny: loaded isUnsaved.
	loaded data keysAndValuesDo: [:k :v|
		((loaded data at: k) isKindOf: DateAndTime) not ifTrue:[
			self assert: (loaded data at: k) = (guy data at: k)]].
	! !

!MaplessMongoTest methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 21:51'!
testSubModelsFromReifiedJSON

	| user guy json reified |
	
	user := MaplessMongoDummyUser new
				userame: 'johnq';
				yourself.
	
	guy := MaplessMongoDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	user person: guy.
		
	json := user unreferenced asJsonString.

	reified := MaplessMongoDummyUser fromJson: json.

	self assert: guy isUnsaved.	
	self assert: reified person class = MaplessMongoDummyPerson.
	self assert: reified completeName = 'john q'.
! !

TestCase subclass: #MaplessRedisModelTest
	instanceVariableNames: 'pool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Redis-Tests'!

!MaplessRedisModelTest methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 17:25'!
do: aBlock 

	pool do:[ :client | ^ aBlock value ]! !

!MaplessRedisModelTest methodsFor: 'setUp-tearDown' stamp: 'sebastiansastre 5/29/2013 22:47'!
setUp
	super setUp.
	pool := RedisPool instance.! !

!MaplessRedisModelTest methodsFor: 'setUp-tearDown' stamp: 'sebastiansastre 5/29/2013 21:53'!
tearDown
	super tearDown.
	pool reset.
	pool := nil! !

!MaplessRedisModelTest methodsFor: 'tests' stamp: 'sebastiansastre 5/30/2013 17:26'!
testUnrefDestroy

	"Tests MaplessMongoModel>>#unreferenced"
	| person tagsCollection loaded reified reloaded |
	
	tagsCollection := OrderedCollection new
		 add: (MaplessRedisDummyTag new
			isCustomer: true;
			yourself);
		add: (MaplessRedisDummyTag new
			isComplicated: false;
			yourself); 
		yourself.
			
	person := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.
	"Save all tags in the collection"
	person tags: tagsCollection.
	self assert: person isUnsaved.
	"save tagsCollection"	
	tagsCollection do: [:e | self do:[ e save]].
	
	self do:[person save].
	self deny: person isUnsaved.
	
	self do:[ loaded := MaplessRedisDummyPerson findAt: person oid].
	
	self assert: loaded notNil.
	self deny: loaded isUnsaved.
	
	self do: [ reified := loaded unreferenced ].

	self assert: reified data tags class = OrderedCollection.
	self assert: (reified data tags first class = MaplessReference) not. 
	self assert: (reified data tags second class = MaplessReference) not.
	
	self assert: reified data tags first isCustomer.
	self assert: (reified data tags second isComplicated = false).
	
	self do: [ reified destroy].
	"self do: [ loaded destroy].
	"
	self assert: ( self do: [ reloaded := MaplessRedisDummyPerson existsAt: reified oid]) not.	

! !

!MaplessRedisModelTest methodsFor: 'tests' stamp: 'sebastiansastre 5/29/2013 22:00'!
testUnrefDestroy2

	| friends guy stuff loaded reified reloaded | 
	
	friends := OrderedCollection new
				add: (MaplessRedisDummyPerson new
						firstName: 'Frodo';
						yourself);
				add: (MaplessRedisDummyPerson new
						firstName: 'Gandalf';
						yourself);
				add: (MaplessRedisDummyPerson new
						firstName: 'Boromir';
						yourself);
				yourself.
				
	stuff := #('Ice cream' 'waffles' 'french fries').
	
	guy := MaplessRedisDummyPerson new
				firstName: 'dude';
				favorites: stuff;
				friends: friends;
				yourself.
	
	self do: [friends do: [:e | e save]].
	self do:[guy save].
	self deny: guy isUnsaved.
	
	self do:[ loaded := MaplessRedisDummyPerson findAt: guy oid].
	
	self assert: loaded notNil.
	self deny: loaded isUnsaved.
	
	self do: [ reified := loaded unreferenced ].

	self assert: reified data friends class = OrderedCollection.
	self do: [ reified destroy].

	"By design, the destruction should be to the individual aggregate (and not its submodels).
	It's programmers' responsability to decide when to destroy a sub aggregate"	
	self assert: ( self do: [ reloaded := MaplessRedisDummyPerson existsAt: loaded oid]) not.	
	self do:[self assert: ((friends collect: [:e| e oid]) allSatisfy: [:guyOid|
					(MaplessRedisDummyPerson existsAt: guyOid)])]

				
	! !

!MaplessRedisModelTest methodsFor: 'tests' stamp: 'sebastiansastre 5/29/2013 22:01'!
testUnreferenced
	"Tests MaplessMongoModel>>#unreferenced"
	| person tagsCollection loaded reified |
	
	tagsCollection := OrderedCollection new
		 add: (MaplessRedisDummyTag new
			isCustomer: true;
			yourself);
		add: (MaplessRedisDummyTag new
			isComplicated: false;
			yourself); 
		yourself.
			
	person := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.
	"Save all tags in the collection"
	person tags: tagsCollection.
	self assert: person isUnsaved.
	"save tagsCollection"	
	tagsCollection do: [:e | self do:[ e save]].
	
	self do:[person save].
	self deny: person isUnsaved.
	
	self do:[ loaded := MaplessRedisDummyPerson findAt: person oid].
	
	self assert: loaded notNil.
	self deny: loaded isUnsaved.
	
	self do: [ reified := loaded unreferenced ].

	self assert: reified data tags class = OrderedCollection.
	self assert: (reified data tags first class = MaplessReference) not. 
	self assert: (reified data tags second class = MaplessReference) not.
	
	self assert: reified data tags first isCustomer.
	self assert: (reified data tags second isComplicated = false).! !

!MaplessRedisModelTest methodsFor: 'tests' stamp: 'sebastiansastre 5/29/2013 22:01'!
testUnreferenced2

	| friends guy stuff loaded reified | 
	
	friends := OrderedCollection new
				add: (MaplessRedisDummyPerson new
						firstName: 'Frodo';
						yourself);
				add: (MaplessRedisDummyPerson new
						firstName: 'Gandalf';
						yourself);
				add: (MaplessRedisDummyPerson new
						firstName: 'Boromir';
						yourself);
				yourself.
				
	stuff := #('Ice cream' 'waffles' 'french fries') asOrderedCollection.
	
	guy := MaplessRedisDummyPerson new
				firstName: 'dude';
				favorites: stuff;
				friends: friends;
				yourself.
	
	friends do: [:e | self do:[ e save]].
	self do:[guy save].
	self deny: guy isUnsaved.
	
	self do:[ loaded := MaplessRedisDummyPerson findAt: guy oid].
	
	self assert: loaded notNil.
	self deny: loaded isUnsaved.
	
	self do: [ reified := loaded unreferenced ].

	self assert: reified data friends class = OrderedCollection.
	self assert: reified data favorites = stuff.
				
	! !

TestCase subclass: #MaplessRedisTest
	instanceVariableNames: 'pool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Redis-Tests'!

!MaplessRedisTest class methodsFor: 'history' stamp: 'sebastiansastre 5/30/2013 18:31'!
lastStoredRun
	^ ((Dictionary new) add: (#passed->((Set new) add: #testDefaultCategoryCleanUp; add: #testPackageCleanUp; add: #testSingleClassCreation; add: #testClassCreationInDifferentCategories; add: #testClassFastCreationInDifferentCategories; add: #testMultipleClassCreation; add: #testSingleClassFastCreation; yourself)); add: (#timeStamp->'22 November 2008 10:11:35 pm'); add: (#failures->((Set new))); add: (#errors->((Set new))); yourself)! !

!MaplessRedisTest methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 18:32'!
do: aBlock 

	pool do:[ :client | ^ aBlock value ]! !

!MaplessRedisTest methodsFor: 'setUp-tearDown' stamp: 'sebastiansastre 5/30/2013 18:33'!
setUp
	super setUp.
	pool := RedisPool instance.! !

!MaplessRedisTest methodsFor: 'setUp-tearDown' stamp: 'sebastiansastre 5/30/2013 18:37'!
tearDown
	super tearDown.

	pool reset.
	pool := nil! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:39'!
testComposedAccess
	"Test proxies and its on-demand-load and DNU mechanism"

	| user guy |
	
	user := MaplessRedisDummyUser new
				userame: 'johnq';
				yourself.
	
	guy := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	user person: guy.

	self do:[ 
		guy save.
		user save ].
	
	self do:[
		self assert: ( MaplessRedisDummyUser findAt: user oid ) completeName = 'john q'.
		self assert: ( MaplessRedisDummyUser findAt: user oid ) person class = MaplessReference.
		self assert: ( MaplessRedisDummyUser findAt: user oid ) person model class = MaplessRedisDummyPerson.
		self assert: ( MaplessRedisDummyUser findAt: user oid ) person firstName = 'john'.
		self assert: ( MaplessRedisDummyUser findAt: user oid ) person lastName = 'q' ]
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:40'!
testComposedDelete

	| users |
	
	users := OrderedCollection new.

	Character alphabet do: [ :char |
		users add: (MaplessRedisDummyUser new 
					userame: char asString;
					person: (MaplessRedisDummyPerson new
								firstName: char asString;
								yourself);
					yourself)].
	
	self assert: ( users allSatisfy: [ :user | user isUnsaved ] ).	
	self assert: ( users allSatisfy: [ :user | user person isUnsaved ] ).	

	self do:[ users do:[ :user | user person save ] ].
	self do:[ users do:[ :user | user save ] ].

	self assert: ( users allSatisfy: [ :user | user isUnsaved not ] ).	
	self assert: ( users allSatisfy: [ :user | user person isUnsaved not ] ).	
	self assert: ( users allSatisfy: [ :user | user isDeleted not ] ).	
	self assert: ( users allSatisfy: [ :user | user person isDeleted not ] ).	

	self do:[ users do:[ :user | user person delete ] ].
	
	self assert: ( users allSatisfy: [ :user | user person isDeleted ] ).	
	self assert: ( users allSatisfy: [ :user | user isDeleted not ] ).	

	self do:[ users do:[ :user | user delete ] ].

	self assert: ( users allSatisfy: [ :user | user person isDeleted ] ).	
	self assert: ( users allSatisfy: [ :user | user isDeleted ] ).	
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:40'!
testComposedDestroy

	| users |
	
	users := OrderedCollection new.

	Character alphabet do: [ :char |
		users add: (MaplessRedisDummyUser new 
					userame: char asString;
					person: (MaplessRedisDummyPerson new
								firstName: char asString;
								yourself);
					yourself)].
	
	self assert: ( users allSatisfy: [ :user | user isUnsaved ] ).	
	self assert: ( users allSatisfy: [ :user | user person isUnsaved ] ).	

	self do:[ users do:[ :user | user person save ] ].
	self do:[ users do:[ :user | user save ] ].

	self assert: ( users allSatisfy: [ :user | user isUnsaved not ] ).	
	self assert: ( users allSatisfy: [ :user | user person isUnsaved not ] ).	

	self do:[ users do:[ :user | user person destroy ] ].
	
	self do:[
		self assert: ( users allSatisfy: [ :user | ( MaplessRedisDummyPerson existsAt: user person oid ) not] ).	
		self assert: ( users allSatisfy: [ :user | MaplessRedisDummyUser existsAt: user oid ] ) ].	

	self do:[ users do:[ :user | user destroy ] ].

	self assert: ( self do: [ users allSatisfy: [ :user | (MaplessRedisDummyUser existsAt: user oid) not ] ] ).	
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:40'!
testComposedSave

	| user guy |
	
	user := MaplessRedisDummyUser new
				userame: 'johnq';
				yourself.
	
	guy := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	user person: guy.
		
	"Whithout saving a submodel"
	self assert: user isUnsaved.	
	self assert: guy isUnsaved.	
	self should: [ self do:[ user save ] ] raise: MaplessUnsavedSubmodel.

	"After saving that submodel"
	self do:[ guy save ].
	self shouldnt: [ self do:[ user save ] ] raise: MaplessUnsavedSubmodel.
	
	self deny: user isUnsaved.	
	self deny: guy isUnsaved.	

! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 6/15/2013 21:00'!
testComposedSaveAndLoad

	| user guy loaded |
	
	user := MaplessRedisDummyUser new
				username: 'johnq';
				yourself.
	
	guy := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	user person: guy.
		
	"Whithout saving a submodel"
	self assert: user isUnsaved.	
	self assert: guy isUnsaved.	
	self should: [ self do:[ user save ] ] raise: MaplessUnsavedSubmodel.

	"After saving that submodel"
	self do:[ guy save ].
	self shouldnt: [ self do:[ user save ] ] raise: MaplessUnsavedSubmodel.
	
	self deny: user isUnsaved.	
	self deny: guy isUnsaved.	

	self do:[ loaded := MaplessRedisDummyUser findAt: user oid.
		self assert: loaded notNil.
		self deny: loaded isUnsaved.
		loaded keysAndValuesDo:[:k :v|
			self assert: (user includesKey: k).
			self assert: (user at: k) = v].
		
		self assert: loaded username = 'johnq'.
		self assert: loaded person firstName = 'john'.
		self assert: loaded person lastName = 'q'.
		self assert: loaded person modelClass = MaplessRedisDummyPerson asString.
		self assert: loaded person model class = MaplessRedisDummyPerson.
		]
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:41'!
testComposition

	| user guy |
	
	user := MaplessRedisDummyUser new
				userame: 'johnq';
				yourself.
	
	guy := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	user person: guy.
		
	self assert: guy isUnsaved.	
	self assert: ((user data at: 'person') class = MaplessReference).
	self assert: ((user data at: 'person') modelClass = #MaplessRedisDummyPerson).
	self assert: ((user data at: 'person') oid = guy oid).
	self assert: (user completeName = 'john q').
	
	
	! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:42'!
testDateAndTime

	| when guy loaded |
	
	when := DateAndTime now.
	guy := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			createdOn: when;
			yourself.
	
	self assert: guy isUnsaved.	
	self do:[ guy save ].
	self deny: guy isUnsaved.

	self do:[ loaded := MaplessRedisDummyPerson findAt: guy id ].

	self assert: loaded createdOn asDate = when asDate.
	self assert: loaded createdOn asTime = when asTime .
	self assert: loaded createdOn = when.
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:42'!
testDelete

	| people |
	
	people := OrderedCollection new.

	Character alphabet do: [ :char |
		people add: (MaplessRedisDummyPerson new
						firstName: char asString;
						yourself)].
	
	self assert: ( people allSatisfy: [ :guy | guy isUnsaved ] ).	

	self do:[ people do:[ :guy | guy save ] ].

	self assert: ( people allSatisfy: [ :guy | guy isUnsaved not ] ).	
	self assert: ( people allSatisfy: [ :guy | guy isDeleted not ] ).	
	
	self do:[ people do:[ :guy | guy delete ] ].
	self assert: ( people allSatisfy: [ :guy | guy isDeleted ] ).	
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:42'!
testDestroy

	| people |
	
	people := OrderedCollection new.

	Character alphabet do: [ :char |
		people add: (MaplessRedisDummyPerson new
						firstName: char asString;
						yourself)].
	
	self assert: ( people allSatisfy: [ :guy | guy isUnsaved ] ).	

	self do:[ people do:[ :guy | guy save ] ].

	self assert: ( people allSatisfy: [ :guy | guy isUnsaved not ] ).	
	self assert: ( people allSatisfy: [ :guy | guy isDeleted not ] ).	
	
	self do:[ people do:[ :guy | guy destroy ] ].
	self assert: ( self do:[ people allSatisfy: [ :guy | ( MaplessRedisDummyPerson existsAt: guy oid ) not ] ]).
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:43'!
testMultipleComposedComposables

	| tags tagsOfTags tagsOfTagsOfTags loaded |

	tags := OrderedCollection new.
	tagsOfTags := OrderedCollection new.
	tagsOfTagsOfTags := OrderedCollection new.

	tags 
		add: (MaplessRedisDummyTag new label: 'is this'; yourself);	
		add: (MaplessRedisDummyTag new label: 'multiply'; yourself);	
		add: (MaplessRedisDummyTag new label: 'composable?'; yourself);	
		yourself.

	tagsOfTags 
		add: (MaplessRedisDummyTag new label: 'like'; yourself);	
		add: (MaplessRedisDummyTag new label: 'really?'; yourself);	
		yourself.

	tagsOfTagsOfTags  
		add: (MaplessRedisDummyTag new label: 'wow'; yourself);	
		add: (MaplessRedisDummyTag new label: 'nice'; yourself);	
		yourself.

	self do:[ tagsOfTagsOfTags do:[ :tag | tag save] ].
	tagsOfTags first tags: tagsOfTagsOfTags.
	tagsOfTags second tags: tagsOfTagsOfTags.
	self shouldnt: [ self do:[ tagsOfTags do:[:tag| tag save ] ]] raise: MaplessUnsavedSubmodel.

	tags first tags: tagsOfTags.
	tags second tags: tagsOfTags.
	tags third tags: tagsOfTags.
	self shouldnt: [ self do:[ tags do:[:e| e save ] ]] raise: MaplessUnsavedSubmodel.
	
	self deny: (tagsOfTagsOfTags anySatisfy: [:tag| tag isUnsaved]).	
	self deny: (tagsOfTags anySatisfy: [:tag| tag isUnsaved]).	
	self deny: (tags anySatisfy: [:tag| tag isUnsaved]).	

	self do:[ 
		loaded := MaplessRedisDummyTag findAt: tags first oid.
		self assert: loaded notNil.
		self deny: loaded isUnsaved.
		self assert: loaded label = 'is this'.
		self assert: loaded tags isCollection.
		self assert: loaded tags notEmpty.
		self assert: loaded tags isCollection.
		self deny: loaded tags first tags isEmpty.
		self assert: loaded tags first label = 'like'.
		self assert: loaded tags second label = 'really?'.
		self assert: loaded tags size = 2.
		self deny: loaded tags first tags isEmpty.
		self assert: loaded tags first tags size = 2.
		self assert: loaded tags first tags first label = 'wow'.
		self assert: loaded tags first tags second label = 'nice'.
		]
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:43'!
testMultipleComposedSaveAndLoad

	| user guy tags loaded |
	
	user := MaplessRedisDummyUser new
				username: 'johnq';
				yourself.
	
	guy := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	tags := OrderedCollection new.
	tags 
		add: (MaplessRedisDummyTag new label: 'cool'; yourself);	
		add: (MaplessRedisDummyTag new label: 'stuff'; yourself);	
		yourself.
		
	user 
		person: guy;
		tags: tags;
		yourself.
		
	self do:[ tags do:[ :tag | tag save] ].
	self do:[ guy save ].
	self shouldnt: [ self do:[ user save ] ] raise: MaplessUnsavedSubmodel.
	
	self deny: user isUnsaved.	
	self deny: guy isUnsaved.	
	self assert: (tags allSatisfy: [:e| e isUnsaved not]).

	self do:[ loaded := MaplessRedisDummyUser findAt: user oid.
		self assert: loaded notNil.
		self deny: loaded isUnsaved.
		self assert: loaded username = 'johnq'.
		self assert: loaded tags isCollection.
		self assert: loaded tags notEmpty.
		self assert: loaded tags isCollection.
		self assert: (loaded tags allSatisfy: [:e| tags includes: e]).
		]
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:43'!
testQueryUsers

	| users |
	
	users := OrderedCollection new.

	Character alphabet do: [ :char |
		users add: (MaplessRedisDummyUser new 
					username: char asString;
					person: (MaplessRedisDummyPerson new
								firstName: char asString;
								yourself);
					yourself)].
	
	self assert: ( users allSatisfy: [ :user | user isUnsaved ] ).	
	self assert: ( users allSatisfy: [ :user | user person isUnsaved ] ).	

	self do:[ users do:[ :user | user person save ] ].
	self do:[ users do:[ :user | user save ] ].

	self do:[ 
		self assert: (Character alphabet allSatisfy: [ :char | 
						( MaplessRedisDummyUser findUsername: char asString ) notNil ] ) ]
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:43'!
testSimpleSave

	| guy |
	
	guy := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.
	
	self assert: guy isUnsaved.	
	self do:[ guy save ].
	self deny: guy isUnsaved.
! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:44'!
testSimpleSaveAndLoad
	| guy loaded |
	
	guy := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.
	
	self assert: guy isUnsaved.	
	self do:[guy save].
	self deny: guy isUnsaved.

	self do:[ loaded := MaplessRedisDummyPerson findAt: guy oid ].
	self assert: loaded notNil.
	self deny: loaded isUnsaved.
	loaded data keysAndValuesDo: [:k :v|
		((loaded data at: k) isKindOf: DateAndTime) not ifTrue:[
			self assert: (loaded data at: k) = (guy data at: k)]].
	! !

!MaplessRedisTest methodsFor: 'testing' stamp: 'sebastiansastre 5/30/2013 18:44'!
testSubModelsFromReifiedJSON

	| user guy json reified |
	
	user := MaplessRedisDummyUser new
				userame: 'johnq';
				yourself.
	
	guy := MaplessRedisDummyPerson new
			firstName: 'john';
			lastName: 'q';
			yourself.

	user person: guy.
		
	json := user unreferenced asJsonString.

	reified := MaplessMongoDummyUser fromJson: json.

	self assert: guy isUnsaved.	
	self assert: reified person class = MaplessMongoDummyPerson.
	self assert: reified completeName = 'john q'.
! !

Exception subclass: #MaplessError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Errors'!

MaplessError subclass: #MaplessModelDataError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Errors'!

MaplessError subclass: #MaplessModelGetterIsMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Errors'!

MaplessError subclass: #MaplessModelMetadataError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Errors'!

MaplessError subclass: #MaplessMongoError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo-Errors'!

MaplessMongoError subclass: #MaplessMongoDatabaseDowntime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo-Errors'!

MaplessMongoError subclass: #MaplessMongoUnavailableDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo-Errors'!

MaplessError subclass: #MaplessRedisError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Redis-Errors'!

MaplessError subclass: #MaplessUnsavedSubmodel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Errors'!

Mongo subclass: #MongoAPI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo'!

!MongoAPI methodsFor: 'testing' stamp: 'sebastiansastre 12/2/2012 17:07'!
isValid 

	^ self isOpen ! !

!MongoAPI methodsFor: 'actions' stamp: 'sebastiansastre 12/2/2012 17:14'!
reset 
	"Close, no fail"
	[ self close ] on: Error do: [ :x |  ] ! !

!Dictionary methodsFor: '*mapless' stamp: 'sebastiansastre 11/30/2012 17:12'!
asJsonObject
	"Answers a JSON object based on the contents of this dictionary."
	
	^ [:json|
		self keysAndValuesDo: [ :k :v| 
			json at: k put: v].
		json ] value: JsonObject new 
		! !

DynamicVariable subclass: #MongoCurrentClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo'!

DynamicVariable subclass: #RedisCurrentClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Redis'!

RedisConnection subclass: #RedisClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Redis'!

!RedisClient methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 23:05'!
isValid

	^ self isConnected! !

!RedisClient methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 17:13'!
remove: aKey
	
	self del: (Array with: aKey)! !

!RedisClient methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 17:13'!
removeAll: someKeys
	
	self del: someKeys! !

!RedisClient methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 23:09'!
reset

	self disconnect! !

Object subclass: #MaplessAbstractPool
	instanceVariableNames: 'clientsMutex busyClients idleClients'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Core'!

MaplessAbstractPool class
	instanceVariableNames: 'instance'!

MaplessAbstractPool class
	instanceVariableNames: 'instance'!

!MaplessAbstractPool class methodsFor: 'initialization' stamp: 'sebastiansastre 4/19/2012 15:57'!
initializeInstance

	^ instance := self new! !

!MaplessAbstractPool class methodsFor: 'accessing' stamp: 'sebastiansastre 4/19/2012 15:57'!
instance 

	^ instance ifNil:[self initializeInstance]! !

!MaplessAbstractPool class methodsFor: 'actions' stamp: 'sebastiansastre 5/14/2012 15:51'!
reset 

	instance ifNotNil:[
		instance reset].
		
	instance := nil! !

!MaplessAbstractPool methodsFor: 'accessing' stamp: 'sebastiansastre 12/1/2012 21:40'!
busyClients 
	"Answers the bunch of clients that are currently busy"
	^ busyClients ifNil:[self initializeBusyClients]! !

!MaplessAbstractPool methodsFor: 'accessing' stamp: 'sebastiansastre 12/1/2012 21:40'!
clientsMutex
	"Answers the mutex used to protect clients usage"
	^ clientsMutex ifNil: [self initializeClientsMutex]! !

!MaplessAbstractPool methodsFor: 'accessing' stamp: 'sebastiansastre 12/2/2012 16:52'!
currentClientDynamicVariable
	"Answers the class of the dynamic variable that will
	hold the value of the current client during the evaluation of its usage."
	^ self subclassResponsibility ! !

!MaplessAbstractPool methodsFor: 'actions' stamp: 'sebastiansastre 12/3/2012 18:26'!
do: aBlock
	"Evaluates aBlock using a client"

	^ self withClientDo: aBlock 
! !

!MaplessAbstractPool methodsFor: 'testing' stamp: 'sebastiansastre 12/1/2012 21:51'!
hasBusyClients
	"Answers true if this pool has, at least one, busy client"
	^ self busyClients notEmpty! !

!MaplessAbstractPool methodsFor: 'testing' stamp: 'sebastiansastre 12/1/2012 21:51'!
hasClients
	"Answers true if this pool has at least one client"
	^ self hasIdleClients or:[
	self hasBusyClients]! !

!MaplessAbstractPool methodsFor: 'testing' stamp: 'sebastiansastre 12/1/2012 21:51'!
hasIdleClients
	"Answers true if this pool has, at least one, idle client"
	^ self idleClients notEmpty! !

!MaplessAbstractPool methodsFor: 'accessing' stamp: 'sebastiansastre 12/1/2012 21:41'!
idleClients 
	"Answers the bunch of clients that are currently idle"
	^ idleClients ifNil:[self initializeIdleClients]! !

!MaplessAbstractPool methodsFor: 'initialization' stamp: 'sebastiansastre 12/1/2012 21:40'!
initializeBusyClients

	^ busyClients := IdentitySet new! !

!MaplessAbstractPool methodsFor: 'initialization' stamp: 'sebastiansastre 12/1/2012 21:40'!
initializeClientsMutex

	^ clientsMutex := Semaphore forMutualExclusion! !

!MaplessAbstractPool methodsFor: 'initialization' stamp: 'sebastiansastre 12/1/2012 21:40'!
initializeIdleClients

	^ idleClients := IdentitySet new! !

!MaplessAbstractPool methodsFor: 'actions' stamp: 'sebastiansastre 12/2/2012 16:57'!
makeClient
	"Returns a new client so it can be (re)used in the pool"
	^ self subclassResponsibility ! !

!MaplessAbstractPool methodsFor: 'actions' stamp: 'sebastiansastre 12/2/2012 16:41'!
printOn: aStream

	super printOn: aStream.
	
	aStream 
		nextPutAll: '(',self busyClients size asString,' busy, ',self idleClients size asString, ' idle)'! !

!MaplessAbstractPool methodsFor: 'actions' stamp: 'sebastiansastre 12/2/2012 18:02'!
remove: aClient

	self idleClients remove: aClient ifAbsent:[ nil ].
	self busyClients remove: aClient ifAbsent:[ nil ].
	! !

!MaplessAbstractPool methodsFor: 'actions' stamp: 'sebastiansastre 5/27/2013 12:08'!
requestClient
	"Answers a aClient instance taken from the idle clients.
	It'll create a new one if needed.
	It's a thread safe operation."

	| client |

	self clientsMutex critical: [
		"Transcript cr; show: 'getting odb client p: ', Processor activeProcess hash asString."
		client := self hasIdleClients
				ifTrue: [ self idleClients anyOne ]
				ifFalse: [ self makeClient ].
		client isValid ifFalse:[
			self remove: client.
			client := self makeClient ].
		self idleClients remove: client ifAbsent:[ nil ].
		self busyClients add: client].
	
	^ client! !

!MaplessAbstractPool methodsFor: 'actions' stamp: 'sebastiansastre 12/2/2012 18:02'!
reset 

	self busyClients copy do:[ :e | 
		e reset. 
		self remove: e ].

	self idleClients copy do:[ :e | 
		e reset.
		self remove: e ].! !

!MaplessAbstractPool methodsFor: 'actions' stamp: 'sebastiansastre 5/27/2013 16:22'!
returnClient: aClient
	"Sends aClient to go from the busy ones to the idle ones
	but only if it's still valid"

	self clientsMutex critical:[
	
		self busyClients remove: aClient ifAbsent: [self returningUnusedClient].		
	
		aClient isValid ifTrue:[
			self idleClients add: aClient] ]! !

!MaplessAbstractPool methodsFor: 'actions' stamp: 'sebastiansastre 12/1/2012 21:49'!
returningUnusedClient

	Transcript cr; show: 'Warning: returning a client that is not in among the busy ones'
! !

!MaplessAbstractPool methodsFor: 'actions' stamp: 'sebastiansastre 12/2/2012 16:55'!
withClientDo: aBlock
	"Evaluates aBlock using one of the 
	(at the moment) idle clients as parameter.
	Other code could reach the client in use by accessing
	the XXCurrentClient dynamic variable's value."

	| client |

	client := self requestClient.
		
	^ self currentClientDynamicVariable value: client during:[
		[aBlock value: client] ensure:[
			self returnClient: client]]
! !

MaplessAbstractPool subclass: #MongoPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo'!

!MongoPool methodsFor: 'accessing' stamp: 'sebastiansastre 12/2/2012 17:04'!
currentClientDynamicVariable
	"Answers the class of the dynamic variable that will
	hold the value of the current client during the evaluation of its usage."
	^ MongoCurrentClient! !

!MongoPool methodsFor: 'actions' stamp: 'sebastiansastre 1/7/2013 17:25'!
databaseAt: aDatabaseName 

	self do:[ :client |
		^ client databaseNamed: aDatabaseName ]! !

!MongoPool methodsFor: 'actions' stamp: 'sebastiansastre 1/8/2013 13:53'!
databaseAt: aDatabaseName do: aBlock

	self do:[ :client |
		(client databaseNamed: aDatabaseName) do: [ ^ aBlock value ] ]! !

!MongoPool methodsFor: 'actions' stamp: 'sebastiansastre 12/9/2012 16:53'!
ifUnavailablePurge: aMongoClient
	"Tests aMongoClient and remove it from this pool if invalid."

	(aMongoClient isOpen not or:[
	([aMongoClient databases first collections.
	true] on: Error do: [:x| false]) not ] ) ifTrue:[ self remove:  aMongoClient]! !

!MongoPool methodsFor: 'actions' stamp: 'sebastiansastre 12/2/2012 17:07'!
makeClient
	"Returns a new client so it can be (re)used in the pool"

	^ MongoAPI default 
		open;
		yourself ! !

!MongoPool methodsFor: 'reactions' stamp: 'sebastiansastre 12/2/2012 17:04'!
onLogout: aMongo

	self remove: aMongo ! !

!MongoPool methodsFor: 'actions' stamp: 'sebastiansastre 12/9/2012 15:49'!
purgeUnavailable
	"Removes any client that might be expired or unreacheable."
	
	self busyClients copy do:[ :e | self ifUnavailablePurge: e ].
	self idleClients copy do:[ :e | self ifUnavailablePurge: e ]! !

MaplessAbstractPool subclass: #RedisPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Redis'!

!RedisPool methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 22:39'!
close: aRedisClient

	aRedisClient isConnected ifTrue:[
		aRedisClient flushAll; quit].
! !

!RedisPool methodsFor: 'accessing' stamp: 'sebastiansastre 5/29/2013 22:07'!
currentClientDynamicVariable
	"Answers the class of the dynamic variable that will
	hold the value of the current client during the evaluation of its usage."
	^ RedisCurrentClient! !

!RedisPool methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 22:42'!
ifUnavailablePurge: aRedisClient
	"Tests aMongoClient and remove it from this pool if invalid."

	aRedisClient isConnected ifFalse:[ self remove:  aRedisClient]! !

!RedisPool methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 23:05'!
makeClient
	"Returns a new client so it can be (re)used in the pool"

	"improve this so it can create connections that are not local"
	^ RedisClient localhost! !

!RedisPool methodsFor: 'reactions' stamp: 'sebastiansastre 5/29/2013 22:43'!
onLogout: aRedisClient
	
	self remove: aRedisClient! !

!RedisPool methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 22:06'!
purgeUnavailable
	"Removes any client that might be expired or unreacheable."
	
	self busyClients copy do:[ :e | self ifUnavailablePurge: e ].
	self idleClients copy do:[ :e | self ifUnavailablePurge: e ]! !

!RedisPool methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 22:43'!
remove: aRedisClient

	self close: aRedisClient.

	super remove: aRedisClient! !

Object subclass: #MaplessMongoBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo'!

!MaplessMongoBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 20:01'!
run

	self runPrintingOn: Transcript ! !

!MaplessMongoBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 20:47'!
runPrintingOn: aStream

	aStream cr;cr; nextPutAll: 'Benchmarking...'; cr; flush.

	(Delay forDuration: 1 second) wait. 
	self save1KPeopleOn: aStream.
	aStream flush.
	Smalltalk garbageCollect; garbageCollect.
	
	(Delay forDuration: 1 second) wait. 
	self save10KPeopleOn: aStream.
	aStream flush.
	Smalltalk garbageCollect; garbageCollect.

	(Delay forDuration: 1 second) wait. 
	self save1KUsersOn: aStream.
	aStream flush.
	Smalltalk garbageCollect; garbageCollect.

	(Delay forDuration: 1 second) wait. 
	self save10KUsersOn: aStream.
	aStream flush.	
	Smalltalk garbageCollect; garbageCollect.
! !

!MaplessMongoBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 12/4/2012 22:39'!
save10KPeopleOn: aStream 

	self save: 10000 peopleOn: aStream ! !

!MaplessMongoBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 12/4/2012 22:38'!
save10KUsersOn: aStream 

	self save: 10000 usersOn: aStream ! !

!MaplessMongoBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 12/4/2012 22:37'!
save1KPeopleOn: aStream 

	self save: 1000 peopleOn: aStream ! !

!MaplessMongoBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 12/4/2012 22:38'!
save1KUsersOn: aStream 

	self save: 1000 usersOn: aStream ! !

!MaplessMongoBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 20:46'!
save: aQuantity peopleOn: aStream 

	| firstNames lastNames delay savesPerSecond guys readsPerSecond |

	firstNames := OrderedCollection new.
	lastNames := OrderedCollection new.
	guys := OrderedCollection new.
	
	1 to: aQuantity do:[ :i |
		firstNames add: Character alphabet shuffled anyOne asString ].

	1 to: aQuantity do:[ :i |
		lastNames add: Character alphabet shuffled anyOne asString ].

	1 to: aQuantity do:[ :i |
		guys add: (MaplessMongoDummyPerson new
					firstName: (firstNames at: i);
					lastName: (lastNames at: i);	
					yourself)].	

	MongoPool instance databaseAt: 'flow' do:[ 
		delay := Time millisecondsToRun: [
			1 to: aQuantity do:[ :i | 
				 (guys at: i) save]]].
	
	savesPerSecond := ((1000 * aQuantity) / delay asFloat) truncated.
	
	aStream cr;
		nextPutAll: 'Saved ';
		nextPutAll: aQuantity asString;
		nextPutAll: ' instances of MaplessMongoDummyPerson in: ';
		nextPutAll: delay milliseconds asString;
		nextPutAll: ' ms ';
		nextPutAll: '(~',savesPerSecond asString,' saves per second)';
		flush.
		
	MongoPool instance databaseAt: 'flow' do:[ 
		delay := Time millisecondsToRun: [
				guys do:[ :guy | 
					MaplessMongoDummyUser findAt: guy oid]]].
	
	readsPerSecond := ((1000 * aQuantity) / delay asFloat) truncated.
	
	aStream cr;
		nextPutAll: 'Read ';
		nextPutAll: aQuantity asString;
		nextPutAll: ' instances of MaplessMongoDummyPerson in: ';
		nextPutAll: delay milliseconds asString;
		nextPutAll: ' ms ';
		nextPutAll: '(~',readsPerSecond asString,' reads per second)';
		flush.	! !

!MaplessMongoBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:17'!
save: aQuantity usersOn: aStream 

	| guy user firstNames lastNames users delay savesPerSecond readsPerSecond |

	firstNames := OrderedCollection new.
	lastNames := OrderedCollection new.
	users := OrderedCollection new.
	
	1 to: aQuantity do:[ :i |
		firstNames add: Character alphabet shuffled anyOne asString ].

	1 to: aQuantity do:[ :i |
		lastNames add: Character alphabet shuffled anyOne asString ].

	1 to: aQuantity do:[ :i | 
		guy := MaplessMongoDummyPerson new
				firstName: (firstNames at: i);
				lastName: (lastNames at: i);
				yourself.
		user := MaplessMongoDummyUser new
					username: guy firstName;
					person: guy;
					yourself.
		users add: user].

	MongoPool instance databaseAt: 'flow' do:[ 
		delay := Time millisecondsToRun: [
				users do:[ :usr | 
					usr person save.
					usr save]]].
	
	savesPerSecond := ((1000 * aQuantity) / delay asFloat) truncated.
	
	aStream cr;
		nextPutAll: 'Saved ';
		nextPutAll: aQuantity asString;
		nextPutAll: ' instances of MaplessMongoDummyPerson and MaplessMongoDummyUser in: ';
		nextPutAll: delay milliseconds asString;
		nextPutAll: ' ms ';
		nextPutAll: '(~',savesPerSecond asString,' saves per second)';
		flush.
		
	MongoPool instance databaseAt: 'flow' do:[ 
		delay := Time millisecondsToRun: [
				users do:[ :usr | 
					user := MaplessMongoDummyUser findAt: usr oid]]].
	
	readsPerSecond := ((1000 * aQuantity) / delay asFloat) truncated.
			
	aStream cr;
		nextPutAll: 'Read ';
		nextPutAll: aQuantity asString;
		nextPutAll: ' instances of MaplessMongoDummyPerson and MaplessMongoDummyUser in: ';
		nextPutAll: delay milliseconds asString;
		nextPutAll: ' ms ';
		nextPutAll: '(~',readsPerSecond asString,' reads per second)';
		flush	
! !

Object subclass: #MaplessPersistentModel
	instanceVariableNames: 'raw data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Models'!

!MaplessPersistentModel commentStamp: 'sebastiansastre 3/15/2012 21:49' prior: 0!
Flow models are meant to be treated as aggregates.

We don't care here about identity.

Why?

Because the idea is that you keep these objects small and uncomplicated enough to be more efficienty serialized/deserialized in JSON for using it is some sort of noSQL persistence support.!

MaplessPersistentModel subclass: #MaplessMongoModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Models'!

!MaplessMongoModel commentStamp: 'sebastiansastre 11/30/2012 13:01' prior: 0!
FlowMongoModel is the abstract class from where subclasses could store and retrieve themselves from and to a MongoDB


!

MaplessMongoModel subclass: #MaplessMongoDummyPerson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo'!

MaplessMongoModel subclass: #MaplessMongoDummyTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo'!

MaplessMongoModel subclass: #MaplessMongoDummyUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Mongo'!

!MaplessMongoDummyUser class methodsFor: 'accessing' stamp: 'sebastiansastre 12/4/2012 18:08'!
findUsername: anUsername

	^ self fromJsonObject: ( self databaseCollection detect: [ :each | 
		( each username = anUsername ) ] )! !

!MaplessMongoDummyUser methodsFor: 'accessing' stamp: 'sebastiansastre 12/3/2012 23:29'!
completeName

	^ self person firstName, ' ', self person lastName! !

!MaplessMongoModel class methodsFor: 'accessing' stamp: 'sebastiansastre 11/30/2012 13:30'!
database
	"Answers the current database (or nil)"

	^ CurrentMongoDatabase value! !

!MaplessMongoModel class methodsFor: 'accessing' stamp: 'sebastiansastre 11/30/2012 13:37'!
databaseCollection
	"Answers the collection for this kind of models hold by the current database"
	
	self ensureCollection.
	
	^ self database collectionAt: self databaseCollectionName! !

!MaplessMongoModel class methodsFor: 'accessing' stamp: 'sebastiansastre 11/30/2012 13:30'!
databaseCollectionName
	"Answers the name for the collection for this kind of models"
	
	^ self name asString! !

!MaplessMongoModel class methodsFor: 'actions' stamp: 'sebastiansastre 11/30/2012 13:38'!
ensureCollection
	"Makes sure there is a collection for this kind of models."
	
	(self database hasCollectionNamed: self databaseCollectionName) ifFalse:[
		self database addCollection: self databaseCollectionName]
! !

!MaplessMongoModel class methodsFor: 'testing' stamp: 'sebastiansastre 12/4/2012 14:25'!
existsAt: aMongoOID

	^ ( self findAt: aMongoOID ) notNil! !

!MaplessMongoModel class methodsFor: 'accessing' stamp: 'sebastiansastre 1/6/2013 00:51'!
findAll
	"Potentially costly operation.
	Returns all objects stored in the collection."
	
	| constraints result |

	constraints := Dictionary new.
	
	result := self databaseCollection query:[:q| 
				q where: constraints].
			
	^ (result isNil and:[
	result isEmpty])
		ifTrue: [ #() ]
		ifFalse: [ self fromJsonObjects: result ]
		! !

!MaplessMongoModel class methodsFor: 'accessing' stamp: 'sebastiansastre 11/30/2012 17:15'!
findAt: aMongoOID

	| oid result |

	oid := Dictionary new 
			at: '_id' put: aMongoOID;
			yourself.

	result := self databaseCollection queryOne:[:q| 
				q where: oid].
			
	^ result isNil
		ifTrue: [ nil ]
		ifFalse: [ self fromJsonObject: result asJsonObject ]
		! !

!MaplessMongoModel class methodsFor: 'accessing' stamp: 'sebastiansastre 1/6/2013 20:19'!
findId: anId

	^ self findAt: anId! !

!MaplessMongoModel class methodsFor: 'accessing' stamp: 'sebastiansastre 1/5/2013 21:46'!
first 

	| constraints result |

	constraints := Dictionary new 
					yourself.

	result := self databaseCollection query:[:q| 
				q 
					where: constraints;
					limit: 1].
				
	^ (result isNil or:[
	result isEmpty])
		ifTrue: [ nil ]
		ifFalse: [ self fromJsonObject: result first asJsonObject ]
		! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 21:49'!
asMaplessReference 

	^ MaplessReference for: self
! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:14'!
asMongoDocument
	"Returns a JsonObject that's BSON friendly."
	
	^ self asMongoDocumentFor: self data! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 1/4/2013 18:10'!
asMongoDocumentFor: aJsonObject
	"Returns a new JsonObject that's the BSON friendly version of aJsonObject
	by visinting all the values. It will complain if sub models are not previously saved."
	
	| mongoDocument storablePart |
		
	mongoDocument := JsonObject new.

	aJsonObject keysAndValuesDo: [ :k :v | 
		storablePart := self asStorable: v.
		mongoDocument 
			at: k
			put: storablePart ].

	^ mongoDocument ! !

!MaplessMongoModel methodsFor: 'accessing' stamp: 'sebastiansastre 6/15/2013 20:29'!
asNoSQLValue
	"Answers this aggregate as value you will expect to have in a noSQL storage"
	
	^ self asJsonString ! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 17:18'!
asStorable: anObject
	"Answers anObject in a way that makes it storable."

	^ anObject isCollection 
		ifTrue: [ anObject collect: [:e| self asStorable: e] ]
		ifFalse: [ (anObject class = MaplessReference)
					ifFalse: [ 
						(anObject isKindOf: MaplessMongoModel)
							ifTrue:[ anObject asMaplessReference asJsonString ] 
							ifFalse:[ anObject ]]
					ifTrue: [
						(anObject hasModel not or:[ 
						anObject isUnsaved not]) 
							ifTrue: [ anObject asJsonString ]
							ifFalse: [ MaplessUnsavedSubmodel signal: 'This sub model is unsaved. You need to save all sub models before saving a composed model' ]]]! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 11/30/2012 13:32'!
beDeleted

	self isDeleted: true! !

!MaplessMongoModel methodsFor: 'accessing' stamp: 'sebastiansastre 11/30/2012 13:31'!
database 
	"Answers the database that is currently being used."
	
	^ self class database ! !

!MaplessMongoModel methodsFor: 'accessing' stamp: 'sebastiansastre 11/30/2012 13:40'!
databaseCollection 
	"Answers the database collection dedicated to this kind of instances."
	
	^ self class databaseCollection ! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 12/4/2012 14:12'!
delete
	"Saves this instance as deleted in the persistent collection"
	
	self onAboutToDelete.
	
	self beDeleted; save.
	
	self onDeleted 
! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 12/4/2012 14:11'!
destroy
	"Removes this instance from the persistent collection"

	| bsonFriendly |
	
	bsonFriendly := self asMongoDocument.

	self onAboutToDestroy.
		
	self class databaseCollection remove: bsonFriendly.
	
	self onDestroyed ! !

!MaplessMongoModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 21:14'!
doesNotUnderstand: aMessage
	"The idea behind this DNU is to use the selector as setters or getter 
	delegating to data (aJsonObject). 
	The mongo model specialization will store sub mongo models wrapped
	in references so serialization and save order is conveniently done."
	
	| key part |

	key := aMessage selector.
	key isUnary ifTrue: [ ^ super doesNotUnderstand: aMessage ].

	^ (key isKeyword and: [(key occurrencesOf: $:) = 1])
		ifTrue: [
			key := key allButLast asSymbol.
			part := aMessage arguments first.
			(part isKindOf: MaplessMongoModel) ifTrue:[
				part := part asMaplessReference ].
			self data at: key asString put: part]
		ifFalse: [super doesNotUnderstand: aMessage]
				
	! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:14'!
ensureOID

	super ensureId.
	
	self hasOID ifFalse:[
		self data at: '_id' put: self id]! !

!MaplessMongoModel methodsFor: 'testing' stamp: 'sebastiansastre 11/30/2012 16:44'!
hasOID 

	^ self oid notNil! !

!MaplessMongoModel methodsFor: 'initialization' stamp: 'sebastiansastre 1/14/2013 06:18'!
initializeOn: aJsonObject 
	"Makes this model to be what aJsonObject dictates it to be."

	super initializeOn: aJsonObject.
	
	self setSubModelsAndReferences
! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:14'!
insert
	
	| bsonFriendly |
		
	self onAboutToInsert.

	[bsonFriendly := self asMongoDocument] ifCurtailed:[
		self data removeKey: '_id' ifAbsent: [ nil ] ] .

	self class databaseCollection add: bsonFriendly.
	
	self onInserted
! !

!MaplessMongoModel methodsFor: 'testing' stamp: 'sebastiansastre 12/4/2012 13:54'!
isDeleted

	^ super isDeleted notNil and:[
	super isDeleted]! !

!MaplessMongoModel methodsFor: 'testing' stamp: 'sebastiansastre 12/3/2012 18:31'!
isUnsaved
	"Answer true if this instance was not saved yet"
	^ self oid isNil ! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 21:49'!
makeReferenceFrom: aJSONString 
	"Answers a new reference from aJSONString (or nil if doesn't feel like one)"

	| jsonObject |

	jsonObject := [ Json readFrom: aJSONString readStream ] ifError: [ :x| nil ].

	^ (jsonObject notNil and:[
	jsonObject oid notNil and:[
	jsonObject modelClass notNil]]) 
		ifTrue:[ MaplessReference fromJsonObject: jsonObject ]
		ifFalse:[ nil ] 
! !

!MaplessMongoModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 21:13'!
oid

	^ self data at: '_id'! !

!MaplessMongoModel methodsFor: 'reactions' stamp: 'sebastiansastre 11/30/2012 14:28'!
onAboutToDelete! !

!MaplessMongoModel methodsFor: 'reactions' stamp: 'sebastiansastre 11/30/2012 14:29'!
onAboutToDestroy! !

!MaplessMongoModel methodsFor: 'reactions' stamp: 'sebastiansastre 12/4/2012 10:44'!
onAboutToInsert

	self ensureOID
! !

!MaplessMongoModel methodsFor: 'reactions' stamp: 'sebastiansastre 1/7/2013 17:13'!
onAboutToSave

	self modifiedOn: DateAndTime now! !

!MaplessMongoModel methodsFor: 'reactions' stamp: 'sebastiansastre 12/3/2012 19:26'!
onAboutToUpdate! !

!MaplessMongoModel methodsFor: 'reactions' stamp: 'sebastiansastre 11/30/2012 14:29'!
onDeleted! !

!MaplessMongoModel methodsFor: 'reactions' stamp: 'sebastiansastre 11/30/2012 14:29'!
onDestroyed! !

!MaplessMongoModel methodsFor: 'reactions' stamp: 'sebastiansastre 12/3/2012 19:36'!
onInserted ! !

!MaplessMongoModel methodsFor: 'reactions' stamp: 'sebastiansastre 11/30/2012 14:28'!
onSaved! !

!MaplessMongoModel methodsFor: 'reactions' stamp: 'sebastiansastre 12/3/2012 19:36'!
onUpdated! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 12/3/2012 19:35'!
save
	"Storage this instance into the persistent collection"
	
	self onAboutToSave.
	
	self isUnsaved
		ifTrue:[ self insert ]
		ifFalse:[ self update ].
		
	self onSaved! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 1/8/2013 19:15'!
setModelFrom: aJsonString on: aKey of: aJsonObject
	"Set model (only if someJsonStrings feels like those)"

	| json modelClass newSubModel |

	json := Json readFrom: aJsonString readStream.	
	modelClass := Smalltalk 
						at: (json at: 'modelClass') asSymbol
						ifAbsent:[self error: 'Cannot find that class'].
							
	newSubModel :=  modelClass fromJsonObject: json.

	newSubModel setSubModels.
	
	 aJsonObject 
		at: aKey 
		put: newSubModel ! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 1/8/2013 19:16'!
setModelsFrom: someJsonStrings on: aKey of: aJsonObject
	"Set models (only if someJsonStrings feels like those)"

	| modelClass newSubModel |

	 aJsonObject 
		at: aKey 
		put: (someJsonStrings collect: [:json| 
				modelClass := Smalltalk 
								at: (json at: 'modelClass') asSymbol
								ifAbsent:[self error: 'Cannot find that class'].
				newSubModel := modelClass fromJson: json.
				newSubModel setSubModels.
				newSubModel])! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 21:49'!
setReferenceFrom: aString on: aKey of: aJsonObject
	"Set a reference (only if aJsonObject feels like one)"

	| jsonObject |

	jsonObject := [ Json readFrom: aString readStream ] ifError: [ :x| nil ].

	(jsonObject notNil and:[
	jsonObject oid notNil and:[
	jsonObject modelClass notNil]]) ifTrue:[ 
		 aJsonObject 
			at: aKey 
			put: ( MaplessReference fromJsonObject: jsonObject ) ] 
! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 1/4/2013 22:14'!
setReferencesFrom: someJsonStrings on: aKey of: aJsonObject
	"Set references (only if someJsonStrings feels like those)"

	 aJsonObject 
		at: aKey 
		put: (someJsonStrings collect: [:json| self makeReferenceFrom: json])! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:12'!
setSubModelReferences
	"Creates proxies to sub models regarding 
	to the JSON data this instance."

	self data keysAndValuesDo: [ :k :v |
		self setSubModelReferencesAt: k with: v]! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:12'!
setSubModelReferencesAt: aKey with: anObject 

	"1. It's a submodel"	
	(anObject isString and:[
	('*oid*' match: anObject) and:[
	('*modelClass*' match: anObject) ] ] )  ifTrue:[ 
		self setReferenceFrom: anObject on: aKey of: self data ].
	
	"2. it's a collection of submodels"
	(anObject isCollection and:[
	anObject notEmpty and:[
	(anObject allSatisfy: [:e| e isString ]) and:[|any|
	any := anObject anyOne.
	('*oid*' match: any) and:[
	('*modelClass*' match: any)]]]]) ifTrue:[
		self setReferencesFrom: anObject on: aKey of: self data].
! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:12'!
setSubModels
	"On demand creates sub models regarding 
	to the JSON data this instance."

	self data keysAndValuesDo: [ :k :v |
		self setSubModelsAt: k with: v]! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 1/14/2013 06:18'!
setSubModelsAndReferences

	self setSubModels.	
	self setSubModelReferences
! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:12'!
setSubModelsAt: aKey with: anObject 

	((anObject isKindOf: JsonObject) and:[
	anObject includesKey: 'modelClass']) ifTrue:[ | modelClass newSubModel |
		modelClass := Smalltalk 
						at: (anObject at: 'modelClass') asSymbol    
						ifAbsent:[self error: 'Could not find that class'].
		newSubModel := modelClass fromJsonObject: anObject.
		newSubModel setSubModels.
		self data at: aKey put: newSubModel]! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:12'!
unreferenced 
	"Returns this model without references to submodels.
	It will reify any proxy (reference to another sub model) found"
	
	self data keysAndValuesDo: [:k :v |
	
		v class = MaplessReference ifTrue:[ |subModel|
			subModel := v model.
			self data at: k put: subModel unreferenced. ].
		"decend one level into arrays which could hold MaplessMongoReference's"
		v isArray ifTrue: [ | unreferencedCollection |
			unreferencedCollection := OrderedCollection new.
			v do: [:each |
				each class = MaplessReference 
					ifFalse:[unreferencedCollection add: each unreferenced]
					ifTrue: [| subModelInArray |
						subModelInArray := each model.
						unreferencedCollection add: subModelInArray unreferenced] 
				].
			self data at: k put: unreferencedCollection.
			]
		]! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 12/4/2012 11:52'!
update

	| bsonFriendly |
	
	bsonFriendly := self asMongoDocument.

	self onAboutToUpdate.

	self class databaseCollection 
		replace:  (Dictionary new 
					at: '_id' put: self oid;
					yourself)
		with: bsonFriendly.
		
	self onUpdated.! !

!MaplessMongoModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:11'!
validateSavedSubModels
	"Navigates this instance's content in search of unsaved sub models
	and complain about it."
	
	self data values do:[ :e |
		(e isKindOf: MaplessReference) ifTrue:[
			e isUnsaved
				ifFalse: [ e validateSavedSubModels ]
				ifTrue:[MaplessUnsavedSubmodel signal: 'This sub model is unsaved. You need to save all sub models before saving a composed model' ] ] ]! !

!MaplessPersistentModel class methodsFor: 'accessing' stamp: 'sebastiansastre 12/3/2012 18:02'!
database

	^ self subclassResponsibility ! !

!MaplessPersistentModel class methodsFor: 'accessing' stamp: 'sebastiansastre 3/18/2012 11:30'!
findAll 

	^ self database objectsAt: self! !

!MaplessPersistentModel class methodsFor: 'accessing' stamp: 'sebastiansastre 1/6/2013 20:04'!
findAllSortedBy: aSelector
	"Answers all instances or ans empty set.
	Note: this is only a good idea when you have very few of this objects
	and starts to become a REALLY BAD idea when you have, for instance, more than 1000."

	|answer|

	answer := TreeSet sortSelector: aSelector equalitySelector: #=.
	self modelClasses do:[:aModelClass|
		aModelClass == MaplessPersistentModel ifFalse:[
			answer addAll: aModelClass findAll]].

	^ answer! !

!MaplessPersistentModel class methodsFor: 'accessing' stamp: 'sebastiansastre 12/4/2012 18:59'!
findId: anId

	^ self subclassResponsibility ! !

!MaplessPersistentModel class methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 20:54'!
fromJson: someJson

	^ self new 
		raw: someJson;
		yourself! !

!MaplessPersistentModel class methodsFor: 'accessing' stamp: 'sebastiansastre 12/7/2012 17:45'!
fromJsonObject: aJsonObjectOrNil

	aJsonObjectOrNil ifNil:[ ^ nil ].

	^ self basicNew 
		initializeOn: aJsonObjectOrNil asJsonObject;
		yourself 
! !

!MaplessPersistentModel class methodsFor: 'accessing' stamp: 'sebastiansastre 11/30/2012 12:53'!
fromJsonObjects: someJsonObjects

	^ someJsonObjects collect:[:e|
		self fromJsonObject: e]! !

!MaplessPersistentModel class methodsFor: 'accessing' stamp: 'sebastiansastre 3/24/2012 10:00'!
fromReified: aJsonObject 

	^ self fromJsonObject: aJsonObject ! !

!MaplessPersistentModel class methodsFor: 'testing' stamp: 'sebastiansastre 1/6/2013 20:04'!
isAbstract
	"Answers true if the model class is abstract.
	Very useful to subclassify a family of model classes 
	of which wouldn't make sense to create instances.

	You can (sub) implement where nessesary in an abstract model like this:
	
	^ self == AnAbstractModelClass"
	
	^ false! !

!MaplessPersistentModel class methodsFor: 'testing' stamp: 'sebastiansastre 1/6/2013 19:59'!
isDeprecated
	"Answers true if the model class is deprecated.
	Very useful for migrations after design changes.

	You can (sub) implement something like this in a deprecated class:
	
	^ self == DeprecatedModelClass"
		
	^ false! !

!MaplessPersistentModel class methodsFor: 'actions' stamp: 'sebastiansastre 3/4/2012 19:31'!
makeId

	^ UUID new asString36! !

!MaplessPersistentModel class methodsFor: 'accessing' stamp: 'sebastiansastre 1/6/2013 19:58'!
modelClasses
	"Answers the set of classes which are concrete model classes.
	Note: deprecated or abstract ones are going to be excluded"

	^ self withAllSubclasses reject: [ :aClass | aClass isAbstract or: [ aClass isDeprecated ] ]! !

!MaplessPersistentModel methodsFor: 'testing' stamp: 'sebastiansastre 3/17/2012 14:43'!
= aModel 
	"Answers true if this model is the same as aModel.
	Note: as you can see, this won't care about identity (yes, that's intentional)."
	^ self id = aModel id! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 11/27/2012 22:44'!
asBSON
	
	^ BSON write: self asBSONFriendly ! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 6/15/2013 20:28'!
asBSONFriendly

	^ Dictionary new 
		at: 'key' put: self id;
		at: 'value' put: self asNoSQLValue;
		yourself! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 11/30/2012 13:43'!
asDictionary 
	"Answers this instance as a JSON friendly dictionary"
	
	^ [:dic| | attributes |
		attributes := OrderedJsonObject new.
		dic at: self class name asString put: attributes.
		self data associationsDo:[:assoc|
			assoc value isPersistentModel 
				ifTrue:[ attributes at: assoc key put: assoc value asDictionary ]
				ifFalse:[ attributes at: assoc key put: assoc value] ].
		dic ] value: OrderedJsonObject new! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'paulwilke 1/30/2013 17:43'!
asJsonString
	
	self onAboutToJSON.

	^ super asJsonString! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 6/15/2013 20:29'!
asNoSQLValue
	"Answers this aggregate as value you will expect to have in a noSQL storage"
	
	self subclassResponsibility ! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 21:04'!
at: aKey

	^ self data at: aKey! !

!MaplessPersistentModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:04'!
at: aKey put: anObject

	^ self data at: aKey put: anObject! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 3/24/2012 11:43'!
createdOn 

	| selector expects object|

	selector := #createdOn.
	expects := DateAndTime.

	object := self at: selector asString.
	object ifNil:[^nil].

	(object isKindOf: expects) ifTrue:[^object].

	^ self at: selector asString put: (self dateAndTimeAt: selector).
! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 20:53'!
data

	^ data ifNil:[self initializeData]! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 3/18/2012 23:32'!
data: aJsonObject

	data := aJsonObject 
	! !

!MaplessPersistentModel methodsFor: 'actions' stamp: 'sebastiansastre 3/24/2012 11:47'!
dateAndTimeAt: aSelector

	^ DateAndTime fromString: (self at: aSelector)! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 21:04'!
doesNotUnderstand: aMessage
	"The idea behind this DNU is to use the selector as setters or getter 
	delegating to data (aJsonObject)"
	
	| key |
	key := aMessage selector.
	key isUnary ifTrue: [^ self data at: key asString].
	^ (key isKeyword and: [(key occurrencesOf: $:) = 1])
		ifTrue: [key := key allButLast asSymbol.
				self data at: key asString put: aMessage arguments first]
		ifFalse: [super doesNotUnderstand: aMessage]
				
	! !

!MaplessPersistentModel methodsFor: 'actions' stamp: 'sebastiansastre 11/30/2012 13:45'!
ensureId 

	self id isNil ifTrue:[
		self id: self class makeId].! !

!MaplessPersistentModel methodsFor: 'actions' stamp: 'sebastiansastre 12/4/2012 19:00'!
fresh

	^ self isUnsaved 
		ifTrue: [ self ]
		ifFalse: [ self class findId: self id ]! !

!MaplessPersistentModel methodsFor: 'initialization' stamp: 'sebastiansastre 5/30/2013 21:05'!
initialize

	super initialize.
	
	self ensureId.
	
	"We include the class name so we have the minimal metadata at consuming time"
	self modelClass: self class name.
	self createdOn: DateAndTime now.
! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 21:05'!
initializeData

	^ raw 
		ifNil:[data := OrderedJsonObject new]
		ifNotNil:[data := Json readFrom: raw readStream]! !

!MaplessPersistentModel methodsFor: 'initialization' stamp: 'sebastiansastre 1/13/2013 23:20'!
initializeOn: aJsonObject

	super initialize.
	
	data := aJsonObject.
	
	self ensureId.
	
	"We include the class name so we have the minimal metadata at consuming time"
	self modelClass ifNil:[
		self modelClass: self class name].

	self createdOn ifNil:[
		self createdOn: DateAndTime now].
! !

!MaplessPersistentModel methodsFor: 'testing' stamp: 'sebastiansastre 3/27/2012 10:43'!
isPersistentModel

	^ true! !

!MaplessPersistentModel methodsFor: 'testing' stamp: 'sebastiansastre 12/4/2012 19:00'!
isUnsaved
	"Answers true if this instance is not saved yet"
	^ self subclassResponsibility ! !

!MaplessPersistentModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 21:06'!
jsonWriteOn: aStream

	self data jsonWriteOn: aStream! !

!MaplessPersistentModel methodsFor: 'reactions' stamp: 'sebastiansastre 1/8/2013 20:36'!
onAboutToJSON
	"This model is about to be stringified in JSON.
	All inst var values that are expected to be model objects, need to be instanciated as expected."

	! !

!MaplessPersistentModel methodsFor: 'reactions' stamp: 'sebastiansastre 5/30/2013 21:07'!
onRead
	"This model has been readed.
	All inst var values that are expected to be model objects, need to be re-instanciated."

	self data keys do:[:key| |value|
		value := self data at: key.
		value isPersistentModel ifTrue:[
			value := value fresh.
			self at: key put: value]].
	! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 20:50'!
raw

	^ raw! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 20:52'!
raw: aJSONString

	raw := aJSONString 
	! !

!MaplessPersistentModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 21:07'!
subModelAt: aSelector
	"Answers the reified submodel (instantiating if necessary)."
	
	| subModelData class |

	subModelData := self data at: aSelector.
	subModelData ifNil:[^nil].

	"legacy code from Amber's json serialization
	subModelData := subModelData at: '@data'.
	subModelData ifNil:[^ FlowModelDataError signal: 'Cannot find ', aSelector,'''s data']."
	
	class := subModelData at: 'class'.
	class := Smalltalk at: class asSymbol ifAbsent:[
		MaplessModelMetadataError signal: 'Cannot find ',aSelector,'''s metadata'].
	
	^ class fromReified: subModelData	! !

MaplessPersistentModel subclass: #MaplessRedisModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Models'!

MaplessRedisModel subclass: #MaplessRedisDummyPerson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Redis'!

MaplessRedisModel subclass: #MaplessRedisDummyTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Redis'!

MaplessRedisModel subclass: #MaplessRedisDummyUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Redis'!

!MaplessRedisDummyUser class methodsFor: 'accessing' stamp: 'sebastiansastre 5/29/2013 22:05'!
findUsername: anUsername

	^ self fromJsonObject: ( self databaseCollection detect: [ :each | 
		( each username = anUsername ) ] )! !

!MaplessRedisDummyUser methodsFor: 'accessing' stamp: 'sebastiansastre 5/29/2013 22:05'!
completeName

	^ self person firstName, ' ', self person lastName! !

!MaplessRedisModel class methodsFor: 'accessing' stamp: 'sebastiansastre 5/29/2013 22:58'!
client
	"Answers the current client (or nil)"

	^ RedisCurrentClient value! !

!MaplessRedisModel class methodsFor: 'accessing' stamp: 'sebastiansastre 5/29/2013 22:58'!
database
	"Redis does not implement databases"

	^ self shouldNotImplement ! !

!MaplessRedisModel class methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 23:21'!
existsAt: anId

	^ self client exists: anId! !

!MaplessRedisModel class methodsFor: 'accessing' stamp: 'sebastiansastre 5/29/2013 19:24'!
findAll
	"Potentially costly operation.
	Returns all objects stored in the collection."
	
	| constraints result |

	constraints := Dictionary new.
	
	result := self databaseCollection query:[:q| 
				q where: constraints].
			
	^ (result isNil and:[
	result isEmpty])
		ifTrue: [ #() ]
		ifFalse: [ self fromJsonObjects: result ]
		! !

!MaplessRedisModel class methodsFor: 'accessing' stamp: 'sebastiansastre 6/15/2013 20:52'!
findAt: anId

	| result |

	result := self client get: anId.
			
	^ result isNil
		ifTrue: [ nil ]
		ifFalse: [ self fromValue: result ]
		! !

!MaplessRedisModel class methodsFor: 'accessing' stamp: 'sebastiansastre 5/29/2013 19:24'!
findId: anId

	^ self findAt: anId! !

!MaplessRedisModel class methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 21:09'!
first 

	| constraints result |

	constraints := Dictionary new 
					yourself.
self halt.
	result := self databaseCollection query:[:q| 
				q 
					where: constraints;
					limit: 1].
				
	^ (result isNil or:[
	result isEmpty])
		ifTrue: [ nil ]
		ifFalse: [ self fromJsonObject: result first asJsonObject ]
		! !

!MaplessRedisModel class methodsFor: 'actions' stamp: 'sebastiansastre 6/15/2013 20:54'!
fromValue: aNoSQLValue 
	
	^ self fromJsonObject: (BSON read: (self unstringify: aNoSQLValue) readStream) asJsonObject ! !

!MaplessRedisModel class methodsFor: 'actions' stamp: 'sebastiansastre 6/15/2013 20:49'!
stringify: aByteArray
	"Answers a string encoding of aByteArray"
	
	^ aByteArray asString base64Encoded ! !

!MaplessRedisModel class methodsFor: 'actions' stamp: 'sebastiansastre 6/15/2013 20:56'!
unstringify: aString
	"Answers a the bytearray encoded into aString"
	
	^ aString base64Decoded asByteArray! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 21:49'!
asMaplessReference 

	^ MaplessReference for: self
! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 6/15/2013 21:01'!
asMongoDocument
	"Returns a JsonObject that's BSON friendly."
	
	^ self asMongoDocumentFor: self data! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
asMongoDocumentFor: aJsonObject
	"Returns a new JsonObject that's the BSON friendly version of aJsonObject
	by visinting all the values. It will complain if sub models are not previously saved."
	
	| mongoDocument storablePart |
		
	mongoDocument := JsonObject new.

	aJsonObject keysAndValuesDo: [ :k :v | 
		storablePart := self asStorable: v.
		mongoDocument 
			at: k
			put: storablePart ].

	^ mongoDocument ! !

!MaplessRedisModel methodsFor: 'accessing' stamp: 'sebastiansastre 6/15/2013 20:50'!
asNoSQLValue
	"Answers this aggregate as value you will expect to have in a noSQL storage"

	| bsonFriendly |
	
	[bsonFriendly := self asMongoDocument] ifCurtailed:[
		self data removeKey: '_id' ifAbsent: [ nil ] ] .
		
	^ self class stringify: (BSON write: bsonFriendly) ! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 17:18'!
asStorable: anObject
	"Answers anObject in a way that makes it storable."

	^ anObject isCollection 
		ifTrue: [ anObject collect: [:e| self asStorable: e] ]
		ifFalse: [ (anObject class = MaplessReference)
					ifFalse: [ 
						(anObject isKindOf: MaplessMongoModel)
							ifTrue:[ anObject asMaplessReference asJsonString ] 
							ifFalse:[ anObject ]]
					ifTrue: [
						(anObject hasModel not or:[ 
						anObject isUnsaved not]) 
							ifTrue: [ anObject asJsonString ]
							ifFalse: [ MaplessUnsavedSubmodel signal: 'This sub model is unsaved. You need to save all sub models before saving a composed model' ]]]! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
beDeleted

	self isDeleted: true! !

!MaplessRedisModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/29/2013 19:23'!
database 
	"Answers the database that is currently being used."
	
	^ self class database ! !

!MaplessRedisModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/29/2013 19:23'!
databaseCollection 
	"Answers the database collection dedicated to this kind of instances."
	
	^ self class databaseCollection ! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
delete
	"Saves this instance as deleted in the persistent collection"
	
	self onAboutToDelete.
	
	self beDeleted; save.
	
	self onDeleted 
! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 17:12'!
destroy
	"Removes this instance from the persistent storage"

	self onAboutToDestroy.
		
	self class client remove: self oid.
	
	self onDestroyed ! !

!MaplessRedisModel methodsFor: 'accessing' stamp: 'sebastiansastre 5/30/2013 19:45'!
doesNotUnderstand: aMessage
	"The idea behind this DNU is to use the selector as setters or getter 
	delegating to data (aJsonObject). 
	The mongo model specialization will store sub mongo models wrapped
	in references so serialization and save order is conveniently done."
	
	| key part |

	key := aMessage selector.
	key isUnary ifTrue: [ ^ super doesNotUnderstand: aMessage ].

	^ (key isKeyword and: [(key occurrencesOf: $:) = 1])
		ifTrue: [
			key := key allButLast asSymbol.
			part := aMessage arguments first.
			(part isKindOf: MaplessRedisModel) ifTrue:[
				part := part asMaplessReference ].
			data at: key asString put: part]
		ifFalse: [super doesNotUnderstand: aMessage]
! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 6/15/2013 19:40'!
ensureOID

	super ensureId.
	
	self data at: '_id' put: self id! !

!MaplessRedisModel methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 19:23'!
hasOID 

	^ self oid notNil! !

!MaplessRedisModel methodsFor: 'initialization' stamp: 'sebastiansastre 5/29/2013 19:24'!
initializeOn: aJsonObject 
	"Makes this model to be what aJsonObject dictates it to be."

	super initializeOn: aJsonObject.
	
	self setSubModelsAndReferences
! !

!MaplessRedisModel methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 19:23'!
isDeleted

	^ super isDeleted notNil and:[
	super isDeleted]! !

!MaplessRedisModel methodsFor: 'testing' stamp: 'sebastiansastre 5/29/2013 19:23'!
isUnsaved
	"Answer true if this instance was not saved yet"
	^ self oid isNil ! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 21:49'!
makeReferenceFrom: aJSONString 
	"Answers a new reference from aJSONString (or nil if doesn't feel like one)"

	| jsonObject |

	jsonObject := [ Json readFrom: aJSONString readStream ] ifError: [ :x| nil ].

	^ (jsonObject notNil and:[
	jsonObject oid notNil and:[
	jsonObject modelClass notNil]]) 
		ifTrue:[ MaplessReference fromJsonObject: jsonObject ]
		ifFalse:[ nil ] 
! !

!MaplessRedisModel methodsFor: 'accessing' stamp: 'sebastiansastre 6/15/2013 19:38'!
oid

	^ self data at: '_id'! !

!MaplessRedisModel methodsFor: 'reactions' stamp: 'sebastiansastre 5/29/2013 19:24'!
onAboutToDelete! !

!MaplessRedisModel methodsFor: 'reactions' stamp: 'sebastiansastre 5/29/2013 19:24'!
onAboutToDestroy! !

!MaplessRedisModel methodsFor: 'reactions' stamp: 'sebastiansastre 5/29/2013 23:01'!
onAboutToSave

	self ensureOID.
	
	self modifiedOn: DateAndTime now! !

!MaplessRedisModel methodsFor: 'reactions' stamp: 'sebastiansastre 5/29/2013 19:24'!
onDeleted! !

!MaplessRedisModel methodsFor: 'reactions' stamp: 'sebastiansastre 5/29/2013 19:24'!
onDestroyed! !

!MaplessRedisModel methodsFor: 'reactions' stamp: 'sebastiansastre 5/29/2013 19:24'!
onSaved! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 6/15/2013 20:51'!
save
	"Storage this instance into the persistent collection"
		
	self onAboutToSave.

	self class client 
		set: self oid 
		value: self asNoSQLValue.
		
	self onSaved! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
setModelFrom: aJsonString on: aKey of: aJsonObject
	"Set model (only if someJsonStrings feels like those)"

	| json modelClass newSubModel |

	json := Json readFrom: aJsonString readStream.	
	modelClass := Smalltalk 
						at: (json at: 'modelClass') asSymbol
						ifAbsent:[self error: 'Cannot find that class'].
							
	newSubModel :=  modelClass fromJsonObject: json.

	newSubModel setSubModels.
	
	 aJsonObject 
		at: aKey 
		put: newSubModel ! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
setModelsFrom: someJsonStrings on: aKey of: aJsonObject
	"Set models (only if someJsonStrings feels like those)"

	| modelClass newSubModel |

	 aJsonObject 
		at: aKey 
		put: (someJsonStrings collect: [:json| 
				modelClass := Smalltalk 
								at: (json at: 'modelClass') asSymbol
								ifAbsent:[self error: 'Cannot find that class'].
				newSubModel := modelClass fromJson: json.
				newSubModel setSubModels.
				newSubModel])! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 21:49'!
setReferenceFrom: aString on: aKey of: aJsonObject
	"Set a reference (only if aJsonObject feels like one)"

	| jsonObject |

	jsonObject := [ Json readFrom: aString readStream ] ifError: [ :x| nil ].

	(jsonObject notNil and:[
	jsonObject oid notNil and:[
	jsonObject modelClass notNil]]) ifTrue:[ 
		 aJsonObject 
			at: aKey 
			put: ( MaplessReference fromJsonObject: jsonObject ) ] 
! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
setReferencesFrom: someJsonStrings on: aKey of: aJsonObject
	"Set references (only if someJsonStrings feels like those)"

	 aJsonObject 
		at: aKey 
		put: (someJsonStrings collect: [:json| self makeReferenceFrom: json])! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
setSubModelReferences
	"Creates proxies to sub models regarding 
	to the JSON data this instance."

	data keysAndValuesDo: [ :k :v |
		self setSubModelReferencesAt: k with: v]! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
setSubModelReferencesAt: aKey with: anObject 

	"1. It's a submodel"	
	(anObject isString and:[
	('*oid*' match: anObject) and:[
	('*modelClass*' match: anObject) ] ] )  ifTrue:[ 
		self setReferenceFrom: anObject on: aKey of: data ].
	
	"2. it's a collection of submodels"
	(anObject isCollection and:[
	anObject notEmpty and:[
	(anObject allSatisfy: [:e| e isString ]) and:[|any|
	any := anObject anyOne.
	('*oid*' match: any) and:[
	('*modelClass*' match: any)]]]]) ifTrue:[
		self setReferencesFrom: anObject on: aKey of: data].
! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
setSubModels
	"On demand creates sub models regarding 
	to the JSON data this instance."

	data keysAndValuesDo: [ :k :v |
		self setSubModelsAt: k with: v]! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
setSubModelsAndReferences

	self setSubModels.	
	self setSubModelReferences
! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 19:23'!
setSubModelsAt: aKey with: anObject 

	((anObject isKindOf: JsonObject) and:[
	anObject includesKey: 'modelClass']) ifTrue:[ | modelClass newSubModel |
		modelClass := Smalltalk 
						at: (anObject at: 'modelClass') asSymbol    
						ifAbsent:[self error: 'Could not find that class'].
		newSubModel := modelClass fromJsonObject: anObject.
		newSubModel setSubModels.
		data at: aKey put: newSubModel]! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/29/2013 21:49'!
unreferenced 
	"Returns this model without references to submodels.
	It will reify any proxy (reference to another sub model) found"
	
	data keysAndValuesDo: [:k :v |
	
		v class = MaplessReference ifTrue:[ |subModel|
			subModel := v model.
			data at: k put: subModel unreferenced. ].
		"decend one level into arrays which could hold MaplessMongoReference's"
		v isArray ifTrue: [ | unreferencedCollection |
			unreferencedCollection := OrderedCollection new.
			v do: [:each |
				each class = MaplessReference 
					ifFalse:[unreferencedCollection add: each unreferenced]
					ifTrue: [| subModelInArray |
						subModelInArray := each model.
						unreferencedCollection add: subModelInArray unreferenced] 
				].
			data at: k put: unreferencedCollection.
			]
		]! !

!MaplessRedisModel methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 17:18'!
validateSavedSubModels
	"Navigates this instance's content in search of unsaved sub models
	and complain about it."
	
	data values do:[ :e |
		(e isKindOf: MaplessReference) ifTrue:[
			e isUnsaved
				ifFalse: [ e validateSavedSubModels ]
				ifTrue:[MaplessUnsavedSubmodel signal: 'This sub model is unsaved. You need to save all sub models before saving a composed model' ] ] ]! !

MaplessPersistentModel subclass: #ToDo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Models'!

MaplessPersistentModel subclass: #ToDoList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Models'!

Object subclass: #MaplessRedisBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Redis'!

!MaplessRedisBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 20:01'!
run

	self runPrintingOn: Transcript ! !

!MaplessRedisBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 20:47'!
runPrintingOn: aStream

	aStream cr; cr; nextPutAll: 'Benchmarking...'; cr; flush.

	(Delay forDuration: 1 second) wait. 
	self save1KPeopleOn: aStream.
	aStream flush.
	Smalltalk garbageCollect; garbageCollect.
	
	(Delay forDuration: 1 second) wait. 
	self save10KPeopleOn: aStream.
	aStream flush.
	Smalltalk garbageCollect; garbageCollect.

	(Delay forDuration: 1 second) wait. 
	self save1KUsersOn: aStream.
	aStream flush.
	Smalltalk garbageCollect; garbageCollect.

	(Delay forDuration: 1 second) wait. 
	self save10KUsersOn: aStream.
	aStream flush.	
	Smalltalk garbageCollect; garbageCollect.
! !

!MaplessRedisBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 19:51'!
save10KPeopleOn: aStream 

	self save: 10000 peopleOn: aStream ! !

!MaplessRedisBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 19:51'!
save10KUsersOn: aStream 

	self save: 10000 usersOn: aStream ! !

!MaplessRedisBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 19:51'!
save1KPeopleOn: aStream 

	self save: 1000 peopleOn: aStream ! !

!MaplessRedisBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 19:51'!
save1KUsersOn: aStream 

	self save: 1000 usersOn: aStream ! !

!MaplessRedisBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 20:45'!
save: aQuantity peopleOn: aStream 

	| guys firstNames lastNames delay savesPerSecond readsPerSecond |

	firstNames := OrderedCollection new.
	lastNames := OrderedCollection new.
	guys := OrderedCollection new.
	
	1 to: aQuantity do:[ :i |
		firstNames add: Character alphabet shuffled anyOne asString ].

	1 to: aQuantity do:[ :i |
		lastNames add: Character alphabet shuffled anyOne asString ].

	1 to: aQuantity do:[ :i | 
		guys add: (MaplessRedisDummyPerson new
					firstName: (firstNames at: i);
					lastName: (lastNames at: i);
					yourself)].

	RedisPool instance do:[ :client |
		delay := Time millisecondsToRun: [
			1 to: aQuantity do:[ :i | 
				(guys at: i) save]]].
	
	savesPerSecond := ((1000 * aQuantity) / delay asFloat) truncated.
	
	aStream cr;
		nextPutAll: 'Saved ';
		nextPutAll: aQuantity asString;
		nextPutAll: ' instances of MaplessRedisDummyPerson in: ';
		nextPutAll: delay milliseconds asString;
		nextPutAll: ' ms ';
		nextPutAll: '(~',savesPerSecond asString,' saves per second)'.
		
	RedisPool instance do:[ :client |
		delay := Time millisecondsToRun: [
				guys do:[ :guy | 
					MaplessRedisDummyUser findAt: guy oid]]].
	
	readsPerSecond := ((1000 * aQuantity) / delay asFloat) truncated.
			
	aStream cr;
		nextPutAll: 'Read ';
		nextPutAll: aQuantity asString;
		nextPutAll: ' instances of MaplessRedisDummyPerson in: ';
		nextPutAll: delay milliseconds asString;
		nextPutAll: ' ms ';
		nextPutAll: '(~',readsPerSecond asString,' reads per second)';
		flush! !

!MaplessRedisBenchmark class methodsFor: 'actions' stamp: 'sebastiansastre 5/30/2013 20:46'!
save: aQuantity usersOn: aStream 

	| guy user firstNames lastNames users delay savesPerSecond readsPerSecond |

	firstNames := OrderedCollection new.
	lastNames := OrderedCollection new.
	users := OrderedCollection new.
	
	1 to: aQuantity do:[ :i |
		firstNames add: Character alphabet shuffled anyOne asString ].

	1 to: aQuantity do:[ :i |
		lastNames add: Character alphabet shuffled anyOne asString ].

	1 to: aQuantity do:[ :i | 
		guy := MaplessRedisDummyPerson new
				firstName: (firstNames at: i);
				lastName: (lastNames at: i);
				yourself.
		user := MaplessRedisDummyUser new
					username: guy firstName;
					person: guy;
					yourself.
		users add: user].

	RedisPool instance do:[ :client |
		delay := Time millisecondsToRun: [
				users do:[ :usr | 
					usr person save.
					usr save]]].
	
	savesPerSecond := ((1000 * aQuantity) / delay asFloat) truncated.
	
	aStream cr;
		nextPutAll: 'Saved ';
		nextPutAll: aQuantity asString;
		nextPutAll: ' instances of MaplessRedisDummyPerson and MaplessRedisDummyUser in: ';
		nextPutAll: delay milliseconds asString;
		nextPutAll: ' ms ';
		nextPutAll: '(~',savesPerSecond asString,' saves per second)';
		flush.
		
	RedisPool instance do:[ :client |
		delay := Time millisecondsToRun: [
				users do:[ :usr | 
					user := MaplessRedisDummyUser findAt: usr oid]]].
	
	readsPerSecond := ((1000 * aQuantity) / delay asFloat) truncated.
			
	aStream cr;
		nextPutAll: 'Read ';
		nextPutAll: aQuantity asString;
		nextPutAll: ' instances of MaplessRedisDummyPerson and MaplessRedisDummyUser in: ';
		nextPutAll: delay milliseconds asString;
		nextPutAll: ' ms ';
		nextPutAll: '(~',readsPerSecond asString,' reads per second)';
		flush
		

! !

Object subclass: #MaplessReference
	instanceVariableNames: 'modelClass oid model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mapless-Core'!

!MaplessReference class methodsFor: 'actions' stamp: 'sebastiansastre 12/3/2012 22:42'!
for: aFlowMongoModel

	^ self new
		initializeOn: aFlowMongoModel;
		yourself ! !

!MaplessReference class methodsFor: 'actions' stamp: 'sebastiansastre 1/7/2013 17:08'!
fromJsonObject: aJsonObject

	^ self new
		oid: aJsonObject oid;
		modelClass: aJsonObject modelClass;
		yourself ! !

!MaplessReference methodsFor: 'accessing' stamp: 'sebastiansastre 1/7/2013 17:09'!
= anObject

	^ super = anObject or:[
	self oid = anObject oid and:[
	self modelClass = anObject modelClass ] ]! !

!MaplessReference methodsFor: 'actions' stamp: 'sebastiansastre 1/7/2013 17:10'!
asJsonObject 

	"The only valid scenario when this won't have an oid 
	is when it has an unsaved model set"
	oid ifNil:[ oid := model oid ].

	"a nil oid at this point should never happen"	
	self assert: oid notNil.

	^ JsonObject new
		at: 'modelClass' put: modelClass;
		at: 'oid' put: oid;
		yourself! !

!MaplessReference methodsFor: 'accessing' stamp: 'sebastiansastre 12/4/2012 19:09'!
doesNotUnderstand: aMessage
	"The idea behind this DNU is to use the selector as setters or getter 
	delegating to data (aJsonObject)"
		
	^ self model 
		perform: aMessage 
		selector withArguments: aMessage arguments 	! !

!MaplessReference methodsFor: 'accessing' stamp: 'sebastiansastre 1/7/2013 17:11'!
getMongoModel

	| class |
	
	class := Smalltalk 
				at: modelClass asSymbol 
				ifAbsent:[ self error: 'This image does not have ',modelClass asString,' class' ].
	
	^ class findAt: oid 
	
	! !

!MaplessReference methodsFor: 'testing' stamp: 'sebastiansastre 12/3/2012 23:18'!
hasModel
 
	^ model notNil! !

!MaplessReference methodsFor: 'initialization' stamp: 'sebastiansastre 1/4/2013 17:14'!
initializeModel 
	"Note this reference will load the model from the database only once,
	usually in the first message send"
	
	model := self getMongoModel.
	
	(model notNil and:[
	model isUnsaved not]) ifTrue:[
		oid := model oid ].
	
	^ model
! !

!MaplessReference methodsFor: 'initialization' stamp: 'sebastiansastre 1/7/2013 17:10'!
initializeOn: aFlowMongoModel

	oid := aFlowMongoModel oid.
	modelClass := aFlowMongoModel class name asString.
	
	model := aFlowMongoModel ! !

!MaplessReference methodsFor: 'testing' stamp: 'sebastiansastre 12/5/2012 20:31'!
isKindOf: aClasss

	^ self model isKindOf: aClasss ! !

!MaplessReference methodsFor: 'actions' stamp: 'sebastiansastre 1/4/2013 19:38'!
jsonWriteOn: aStream

	self asJsonObject jsonWriteOn: aStream! !

!MaplessReference methodsFor: 'accessing' stamp: 'sebastiansastre 12/4/2012 19:09'!
model
	^ model ifNil:[ self initializeModel ]! !

!MaplessReference methodsFor: 'accessing' stamp: 'sebastiansastre 12/4/2012 19:08'!
model: anObject
	model := anObject! !

!MaplessReference methodsFor: 'accessing' stamp: 'sebastiansastre 1/7/2013 17:08'!
modelClass
	^ modelClass! !

!MaplessReference methodsFor: 'accessing' stamp: 'sebastiansastre 1/7/2013 17:08'!
modelClass: anObject
	modelClass := anObject! !

!MaplessReference methodsFor: 'accessing' stamp: 'sebastiansastre 12/1/2012 06:51'!
oid
	^ oid! !

!MaplessReference methodsFor: 'accessing' stamp: 'sebastiansastre 12/1/2012 06:51'!
oid: anObject
	oid := anObject! !

!MaplessReference methodsFor: 'actions' stamp: 'sebastiansastre 2/13/2013 16:00'!
unreferenced 

	^ self model unreferenced ! !

!Object methodsFor: '*mapless' stamp: 'sebastiansastre 1/16/2013 18:53'!
unreferenced

	^ self! !
